'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PropTypes = _interopDefault(require('prop-types'));
var React = require('react');
var React__default = _interopDefault(React);
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var reactDom = _interopDefault(require('react-dom'));
var ReactSlider = _interopDefault(require('react-slick'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

/*!
 * Font Awesome Free 5.5.0 by @fontawesome - https://fontawesome.com
 * License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License)
 */
var noop = function noop() {};

var _WINDOW = {};
var _DOCUMENT = {};
var _PERFORMANCE = { mark: noop, measure: noop };

try {
  if (typeof window !== 'undefined') _WINDOW = window;
  if (typeof document !== 'undefined') _DOCUMENT = document;
  if (typeof performance !== 'undefined') _PERFORMANCE = performance;
} catch (e) {}

var _ref = _WINDOW.navigator || {};
var _ref$userAgent = _ref.userAgent;
var userAgent = _ref$userAgent === undefined ? '' : _ref$userAgent;

var WINDOW = _WINDOW;
var DOCUMENT = _DOCUMENT;
var PERFORMANCE = _PERFORMANCE;

var IS_DOM = !!DOCUMENT.documentElement && !!DOCUMENT.head && typeof DOCUMENT.addEventListener === 'function' && typeof DOCUMENT.createElement === 'function';
var IS_IE = ~userAgent.indexOf('MSIE') || ~userAgent.indexOf('Trident/');

var NAMESPACE_IDENTIFIER = '___FONT_AWESOME___';
var DEFAULT_FAMILY_PREFIX = 'fa';
var DEFAULT_REPLACEMENT_CLASS = 'svg-inline--fa';
var DATA_FA_I2SVG = 'data-fa-i2svg';
var PRODUCTION = function () {
  try {
    return process.env.NODE_ENV === 'production';
  } catch (e) {
    return false;
  }
}();

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();



var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var initial = WINDOW.FontAwesomeConfig || {};

function getAttrConfig(attr) {
  var element = DOCUMENT.querySelector('script[' + attr + ']');

  if (element) {
    return element.getAttribute(attr);
  }
}

function coerce(val) {
  // Getting an empty string will occur if the attribute is set on the HTML tag but without a value
  // We'll assume that this is an indication that it should be toggled to true
  // For example <script data-search-pseudo-elements src="..."></script>
  if (val === '') return true;
  if (val === 'false') return false;
  if (val === 'true') return true;
  return val;
}

if (DOCUMENT && typeof DOCUMENT.querySelector === 'function') {
  var attrs = [['data-family-prefix', 'familyPrefix'], ['data-replacement-class', 'replacementClass'], ['data-auto-replace-svg', 'autoReplaceSvg'], ['data-auto-add-css', 'autoAddCss'], ['data-auto-a11y', 'autoA11y'], ['data-search-pseudo-elements', 'searchPseudoElements'], ['data-observe-mutations', 'observeMutations'], ['data-keep-original-source', 'keepOriginalSource'], ['data-measure-performance', 'measurePerformance'], ['data-show-missing-icons', 'showMissingIcons']];

  attrs.forEach(function (_ref) {
    var _ref2 = slicedToArray(_ref, 2),
        attr = _ref2[0],
        key = _ref2[1];

    var val = coerce(getAttrConfig(attr));

    if (val !== undefined && val !== null) {
      initial[key] = val;
    }
  });
}

var _default = _extends({
  familyPrefix: DEFAULT_FAMILY_PREFIX,
  replacementClass: DEFAULT_REPLACEMENT_CLASS,
  autoReplaceSvg: true,
  autoAddCss: true,
  autoA11y: true,
  searchPseudoElements: false,
  observeMutations: true,
  keepOriginalSource: true,
  measurePerformance: false,
  showMissingIcons: true
}, initial);

if (!_default.autoReplaceSvg) _default.observeMutations = false;

var config = _extends({}, _default);

WINDOW.FontAwesomeConfig = config;

var w = WINDOW || {};

if (!w[NAMESPACE_IDENTIFIER]) w[NAMESPACE_IDENTIFIER] = {};
if (!w[NAMESPACE_IDENTIFIER].styles) w[NAMESPACE_IDENTIFIER].styles = {};
if (!w[NAMESPACE_IDENTIFIER].hooks) w[NAMESPACE_IDENTIFIER].hooks = {};
if (!w[NAMESPACE_IDENTIFIER].shims) w[NAMESPACE_IDENTIFIER].shims = [];

var namespace = w[NAMESPACE_IDENTIFIER];

var functions = [];
var listener = function listener() {
  DOCUMENT.removeEventListener('DOMContentLoaded', listener);
  loaded = 1;
  functions.map(function (fn) {
    return fn();
  });
};

var loaded = false;

if (IS_DOM) {
  loaded = (DOCUMENT.documentElement.doScroll ? /^loaded|^c/ : /^loaded|^i|^c/).test(DOCUMENT.readyState);

  if (!loaded) DOCUMENT.addEventListener('DOMContentLoaded', listener);
}

var meaninglessTransform = {
  size: 16,
  x: 0,
  y: 0,
  rotate: 0,
  flipX: false,
  flipY: false
};



function insertCss(css) {
  if (!css || !IS_DOM) {
    return;
  }

  var style = DOCUMENT.createElement('style');
  style.setAttribute('type', 'text/css');
  style.innerHTML = css;

  var headChildren = DOCUMENT.head.childNodes;
  var beforeChild = null;

  for (var i = headChildren.length - 1; i > -1; i--) {
    var child = headChildren[i];
    var tagName = (child.tagName || '').toUpperCase();
    if (['STYLE', 'LINK'].indexOf(tagName) > -1) {
      beforeChild = child;
    }
  }

  DOCUMENT.head.insertBefore(style, beforeChild);

  return css;
}

var idPool = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';

function nextUniqueId() {
  var size = 12;
  var id = '';
  while (size-- > 0) {
    id += idPool[Math.random() * 62 | 0];
  }
  return id;
}

function htmlEscape(str) {
  return ('' + str).replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/'/g, '&#39;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}

function joinAttributes(attributes) {
  return Object.keys(attributes || {}).reduce(function (acc, attributeName) {
    return acc + (attributeName + '="' + htmlEscape(attributes[attributeName]) + '" ');
  }, '').trim();
}

function joinStyles(styles) {
  return Object.keys(styles || {}).reduce(function (acc, styleName) {
    return acc + (styleName + ': ' + styles[styleName] + ';');
  }, '');
}

function transformIsMeaningful(transform) {
  return transform.size !== meaninglessTransform.size || transform.x !== meaninglessTransform.x || transform.y !== meaninglessTransform.y || transform.rotate !== meaninglessTransform.rotate || transform.flipX || transform.flipY;
}

function transformForSvg(_ref) {
  var transform = _ref.transform,
      containerWidth = _ref.containerWidth,
      iconWidth = _ref.iconWidth;

  var outer = {
    transform: 'translate(' + containerWidth / 2 + ' 256)'
  };
  var innerTranslate = 'translate(' + transform.x * 32 + ', ' + transform.y * 32 + ') ';
  var innerScale = 'scale(' + transform.size / 16 * (transform.flipX ? -1 : 1) + ', ' + transform.size / 16 * (transform.flipY ? -1 : 1) + ') ';
  var innerRotate = 'rotate(' + transform.rotate + ' 0 0)';
  var inner = {
    transform: innerTranslate + ' ' + innerScale + ' ' + innerRotate
  };
  var path = {
    transform: 'translate(' + iconWidth / 2 * -1 + ' -256)'
  };
  return {
    outer: outer,
    inner: inner,
    path: path
  };
}

var ALL_SPACE = {
  x: 0,
  y: 0,
  width: '100%',
  height: '100%'
};

var makeIconMasking = function (_ref) {
  var children = _ref.children,
      attributes = _ref.attributes,
      main = _ref.main,
      mask = _ref.mask,
      transform = _ref.transform;
  var mainWidth = main.width,
      mainPath = main.icon;
  var maskWidth = mask.width,
      maskPath = mask.icon;


  var trans = transformForSvg({ transform: transform, containerWidth: maskWidth, iconWidth: mainWidth });

  var maskRect = {
    tag: 'rect',
    attributes: _extends({}, ALL_SPACE, {
      fill: 'white'
    })
  };
  var maskInnerGroup = {
    tag: 'g',
    attributes: _extends({}, trans.inner),
    children: [{ tag: 'path', attributes: _extends({}, mainPath.attributes, trans.path, { fill: 'black' }) }]
  };
  var maskOuterGroup = {
    tag: 'g',
    attributes: _extends({}, trans.outer),
    children: [maskInnerGroup]
  };
  var maskId = 'mask-' + nextUniqueId();
  var clipId = 'clip-' + nextUniqueId();
  var maskTag = {
    tag: 'mask',
    attributes: _extends({}, ALL_SPACE, {
      id: maskId,
      maskUnits: 'userSpaceOnUse',
      maskContentUnits: 'userSpaceOnUse'
    }),
    children: [maskRect, maskOuterGroup]
  };
  var defs = {
    tag: 'defs',
    children: [{ tag: 'clipPath', attributes: { id: clipId }, children: [maskPath] }, maskTag]
  };

  children.push(defs, { tag: 'rect', attributes: _extends({ fill: 'currentColor', 'clip-path': 'url(#' + clipId + ')', mask: 'url(#' + maskId + ')' }, ALL_SPACE) });

  return {
    children: children,
    attributes: attributes
  };
};

var makeIconStandard = function (_ref) {
  var children = _ref.children,
      attributes = _ref.attributes,
      main = _ref.main,
      transform = _ref.transform,
      styles = _ref.styles;

  var styleString = joinStyles(styles);

  if (styleString.length > 0) {
    attributes['style'] = styleString;
  }

  if (transformIsMeaningful(transform)) {
    var trans = transformForSvg({ transform: transform, containerWidth: main.width, iconWidth: main.width });
    children.push({
      tag: 'g',
      attributes: _extends({}, trans.outer),
      children: [{
        tag: 'g',
        attributes: _extends({}, trans.inner),
        children: [{
          tag: main.icon.tag,
          children: main.icon.children,
          attributes: _extends({}, main.icon.attributes, trans.path)
        }]
      }]
    });
  } else {
    children.push(main.icon);
  }

  return {
    children: children,
    attributes: attributes
  };
};

var asIcon = function (_ref) {
  var children = _ref.children,
      main = _ref.main,
      mask = _ref.mask,
      attributes = _ref.attributes,
      styles = _ref.styles,
      transform = _ref.transform;

  if (transformIsMeaningful(transform) && main.found && !mask.found) {
    var width = main.width,
        height = main.height;

    var offset = {
      x: width / height / 2,
      y: 0.5
    };
    attributes['style'] = joinStyles(_extends({}, styles, {
      'transform-origin': offset.x + transform.x / 16 + 'em ' + (offset.y + transform.y / 16) + 'em'
    }));
  }

  return [{
    tag: 'svg',
    attributes: attributes,
    children: children
  }];
};

var asSymbol = function (_ref) {
  var prefix = _ref.prefix,
      iconName = _ref.iconName,
      children = _ref.children,
      attributes = _ref.attributes,
      symbol = _ref.symbol;

  var id = symbol === true ? prefix + '-' + config.familyPrefix + '-' + iconName : symbol;

  return [{
    tag: 'svg',
    attributes: {
      style: 'display: none;'
    },
    children: [{
      tag: 'symbol',
      attributes: _extends({}, attributes, { id: id }),
      children: children
    }]
  }];
};

function makeInlineSvgAbstract(params) {
  var _params$icons = params.icons,
      main = _params$icons.main,
      mask = _params$icons.mask,
      prefix = params.prefix,
      iconName = params.iconName,
      transform = params.transform,
      symbol = params.symbol,
      title = params.title,
      extra = params.extra,
      _params$watchable = params.watchable,
      watchable = _params$watchable === undefined ? false : _params$watchable;

  var _ref = mask.found ? mask : main,
      width = _ref.width,
      height = _ref.height;

  var widthClass = 'fa-w-' + Math.ceil(width / height * 16);
  var attrClass = [config.replacementClass, iconName ? config.familyPrefix + '-' + iconName : '', widthClass].filter(function (c) {
    return extra.classes.indexOf(c) === -1;
  }).concat(extra.classes).join(' ');

  var content = {
    children: [],
    attributes: _extends({}, extra.attributes, {
      'data-prefix': prefix,
      'data-icon': iconName,
      'class': attrClass,
      'role': 'img',
      'xmlns': 'http://www.w3.org/2000/svg',
      'viewBox': '0 0 ' + width + ' ' + height
    })
  };

  if (watchable) {
    content.attributes[DATA_FA_I2SVG] = '';
  }

  if (title) content.children.push({ tag: 'title', attributes: { id: content.attributes['aria-labelledby'] || 'title-' + nextUniqueId() }, children: [title] });

  var args = _extends({}, content, {
    prefix: prefix,
    iconName: iconName,
    main: main,
    mask: mask,
    transform: transform,
    symbol: symbol,
    styles: extra.styles
  });

  var _ref2 = mask.found && main.found ? makeIconMasking(args) : makeIconStandard(args),
      children = _ref2.children,
      attributes = _ref2.attributes;

  args.children = children;
  args.attributes = attributes;

  if (symbol) {
    return asSymbol(args);
  } else {
    return asIcon(args);
  }
}

var noop$2 = function noop() {};
var p = config.measurePerformance && PERFORMANCE && PERFORMANCE.mark && PERFORMANCE.measure ? PERFORMANCE : { mark: noop$2, measure: noop$2 };

/**
 * Internal helper to bind a function known to have 4 arguments
 * to a given context.
 */
var bindInternal4 = function bindInternal4 (func, thisContext) {
  return function (a, b, c, d) {
    return func.call(thisContext, a, b, c, d);
  };
};



/**
 * # Reduce
 *
 * A fast object `.reduce()` implementation.
 *
 * @param  {Object}   subject      The object to reduce over.
 * @param  {Function} fn           The reducer function.
 * @param  {mixed}    initialValue The initial value for the reducer, defaults to subject[0].
 * @param  {Object}   thisContext  The context for the reducer.
 * @return {mixed}                 The final result.
 */
var reduce = function fastReduceObject (subject, fn, initialValue, thisContext) {
  var keys = Object.keys(subject),
      length = keys.length,
      iterator = thisContext !== undefined ? bindInternal4(fn, thisContext) : fn,
      i, key, result;

  if (initialValue === undefined) {
    i = 1;
    result = subject[keys[0]];
  }
  else {
    i = 0;
    result = initialValue;
  }

  for (; i < length; i++) {
    key = keys[i];
    result = iterator(result, subject[key], key, subject);
  }

  return result;
};

var styles$2 = namespace.styles;
var shims = namespace.shims;


var _byUnicode = {};
var _byLigature = {};
var _byOldName = {};

var build = function build() {
  var lookup = function lookup(reducer) {
    return reduce(styles$2, function (o, style, prefix) {
      o[prefix] = reduce(style, reducer, {});
      return o;
    }, {});
  };

  _byUnicode = lookup(function (acc, icon, iconName) {
    acc[icon[3]] = iconName;

    return acc;
  });

  _byLigature = lookup(function (acc, icon, iconName) {
    var ligatures = icon[2];

    acc[iconName] = iconName;

    ligatures.forEach(function (ligature) {
      acc[ligature] = iconName;
    });

    return acc;
  });

  var hasRegular = 'far' in styles$2;

  _byOldName = reduce(shims, function (acc, shim) {
    var oldName = shim[0];
    var prefix = shim[1];
    var iconName = shim[2];

    if (prefix === 'far' && !hasRegular) {
      prefix = 'fas';
    }

    acc[oldName] = { prefix: prefix, iconName: iconName };

    return acc;
  }, {});
};

build();

var styles$1 = namespace.styles;

function iconFromMapping(mapping, prefix, iconName) {
  if (mapping && mapping[prefix] && mapping[prefix][iconName]) {
    return {
      prefix: prefix,
      iconName: iconName,
      icon: mapping[prefix][iconName]
    };
  }
}

function toHtml(abstractNodes) {
  var tag = abstractNodes.tag,
      _abstractNodes$attrib = abstractNodes.attributes,
      attributes = _abstractNodes$attrib === undefined ? {} : _abstractNodes$attrib,
      _abstractNodes$childr = abstractNodes.children,
      children = _abstractNodes$childr === undefined ? [] : _abstractNodes$childr;


  if (typeof abstractNodes === 'string') {
    return htmlEscape(abstractNodes);
  } else {
    return '<' + tag + ' ' + joinAttributes(attributes) + '>' + children.map(toHtml).join('') + '</' + tag + '>';
  }
}

var parseTransformString = function parseTransformString(transformString) {
  var transform = {
    size: 16,
    x: 0,
    y: 0,
    flipX: false,
    flipY: false,
    rotate: 0
  };

  if (!transformString) {
    return transform;
  } else {
    return transformString.toLowerCase().split(' ').reduce(function (acc, n) {
      var parts = n.toLowerCase().split('-');
      var first = parts[0];
      var rest = parts.slice(1).join('-');

      if (first && rest === 'h') {
        acc.flipX = true;
        return acc;
      }

      if (first && rest === 'v') {
        acc.flipY = true;
        return acc;
      }

      rest = parseFloat(rest);

      if (isNaN(rest)) {
        return acc;
      }

      switch (first) {
        case 'grow':
          acc.size = acc.size + rest;
          break;
        case 'shrink':
          acc.size = acc.size - rest;
          break;
        case 'left':
          acc.x = acc.x - rest;
          break;
        case 'right':
          acc.x = acc.x + rest;
          break;
        case 'up':
          acc.y = acc.y - rest;
          break;
        case 'down':
          acc.y = acc.y + rest;
          break;
        case 'rotate':
          acc.rotate = acc.rotate + rest;
          break;
      }

      return acc;
    }, transform);
  }
};

function MissingIcon(error) {
  this.name = 'MissingIcon';
  this.message = error || 'Icon unavailable';
  this.stack = new Error().stack;
}

MissingIcon.prototype = Object.create(Error.prototype);
MissingIcon.prototype.constructor = MissingIcon;

var FILL = { fill: 'currentColor' };
var ANIMATION_BASE = {
  attributeType: 'XML',
  repeatCount: 'indefinite',
  dur: '2s'
};
var RING = {
  tag: 'path',
  attributes: _extends({}, FILL, {
    d: 'M156.5,447.7l-12.6,29.5c-18.7-9.5-35.9-21.2-51.5-34.9l22.7-22.7C127.6,430.5,141.5,440,156.5,447.7z M40.6,272H8.5 c1.4,21.2,5.4,41.7,11.7,61.1L50,321.2C45.1,305.5,41.8,289,40.6,272z M40.6,240c1.4-18.8,5.2-37,11.1-54.1l-29.5-12.6 C14.7,194.3,10,216.7,8.5,240H40.6z M64.3,156.5c7.8-14.9,17.2-28.8,28.1-41.5L69.7,92.3c-13.7,15.6-25.5,32.8-34.9,51.5 L64.3,156.5z M397,419.6c-13.9,12-29.4,22.3-46.1,30.4l11.9,29.8c20.7-9.9,39.8-22.6,56.9-37.6L397,419.6z M115,92.4 c13.9-12,29.4-22.3,46.1-30.4l-11.9-29.8c-20.7,9.9-39.8,22.6-56.8,37.6L115,92.4z M447.7,355.5c-7.8,14.9-17.2,28.8-28.1,41.5 l22.7,22.7c13.7-15.6,25.5-32.9,34.9-51.5L447.7,355.5z M471.4,272c-1.4,18.8-5.2,37-11.1,54.1l29.5,12.6 c7.5-21.1,12.2-43.5,13.6-66.8H471.4z M321.2,462c-15.7,5-32.2,8.2-49.2,9.4v32.1c21.2-1.4,41.7-5.4,61.1-11.7L321.2,462z M240,471.4c-18.8-1.4-37-5.2-54.1-11.1l-12.6,29.5c21.1,7.5,43.5,12.2,66.8,13.6V471.4z M462,190.8c5,15.7,8.2,32.2,9.4,49.2h32.1 c-1.4-21.2-5.4-41.7-11.7-61.1L462,190.8z M92.4,397c-12-13.9-22.3-29.4-30.4-46.1l-29.8,11.9c9.9,20.7,22.6,39.8,37.6,56.9 L92.4,397z M272,40.6c18.8,1.4,36.9,5.2,54.1,11.1l12.6-29.5C317.7,14.7,295.3,10,272,8.5V40.6z M190.8,50 c15.7-5,32.2-8.2,49.2-9.4V8.5c-21.2,1.4-41.7,5.4-61.1,11.7L190.8,50z M442.3,92.3L419.6,115c12,13.9,22.3,29.4,30.5,46.1 l29.8-11.9C470,128.5,457.3,109.4,442.3,92.3z M397,92.4l22.7-22.7c-15.6-13.7-32.8-25.5-51.5-34.9l-12.6,29.5 C370.4,72.1,384.4,81.5,397,92.4z'
  })
};
var OPACITY_ANIMATE = _extends({}, ANIMATION_BASE, {
  attributeName: 'opacity'
});
var DOT = {
  tag: 'circle',
  attributes: _extends({}, FILL, {
    cx: '256',
    cy: '364',
    r: '28'
  }),
  children: [{ tag: 'animate', attributes: _extends({}, ANIMATION_BASE, { attributeName: 'r', values: '28;14;28;28;14;28;' }) }, { tag: 'animate', attributes: _extends({}, OPACITY_ANIMATE, { values: '1;0;1;1;0;1;' }) }]
};
var QUESTION = {
  tag: 'path',
  attributes: _extends({}, FILL, {
    opacity: '1',
    d: 'M263.7,312h-16c-6.6,0-12-5.4-12-12c0-71,77.4-63.9,77.4-107.8c0-20-17.8-40.2-57.4-40.2c-29.1,0-44.3,9.6-59.2,28.7 c-3.9,5-11.1,6-16.2,2.4l-13.1-9.2c-5.6-3.9-6.9-11.8-2.6-17.2c21.2-27.2,46.4-44.7,91.2-44.7c52.3,0,97.4,29.8,97.4,80.2 c0,67.6-77.4,63.5-77.4,107.8C275.7,306.6,270.3,312,263.7,312z'
  }),
  children: [{ tag: 'animate', attributes: _extends({}, OPACITY_ANIMATE, { values: '1;0;0;0;0;1;' }) }]
};
var EXCLAMATION = {
  tag: 'path',
  attributes: _extends({}, FILL, {
    opacity: '0',
    d: 'M232.5,134.5l7,168c0.3,6.4,5.6,11.5,12,11.5h9c6.4,0,11.7-5.1,12-11.5l7-168c0.3-6.8-5.2-12.5-12-12.5h-23 C237.7,122,232.2,127.7,232.5,134.5z'
  }),
  children: [{ tag: 'animate', attributes: _extends({}, OPACITY_ANIMATE, { values: '0;0;1;1;0;0;' }) }]
};

var styles = namespace.styles;

var baseStyles = "svg:not(:root).svg-inline--fa {\n  overflow: visible; }\n\n.svg-inline--fa {\n  display: inline-block;\n  font-size: inherit;\n  height: 1em;\n  overflow: visible;\n  vertical-align: -.125em; }\n  .svg-inline--fa.fa-lg {\n    vertical-align: -.225em; }\n  .svg-inline--fa.fa-w-1 {\n    width: 0.0625em; }\n  .svg-inline--fa.fa-w-2 {\n    width: 0.125em; }\n  .svg-inline--fa.fa-w-3 {\n    width: 0.1875em; }\n  .svg-inline--fa.fa-w-4 {\n    width: 0.25em; }\n  .svg-inline--fa.fa-w-5 {\n    width: 0.3125em; }\n  .svg-inline--fa.fa-w-6 {\n    width: 0.375em; }\n  .svg-inline--fa.fa-w-7 {\n    width: 0.4375em; }\n  .svg-inline--fa.fa-w-8 {\n    width: 0.5em; }\n  .svg-inline--fa.fa-w-9 {\n    width: 0.5625em; }\n  .svg-inline--fa.fa-w-10 {\n    width: 0.625em; }\n  .svg-inline--fa.fa-w-11 {\n    width: 0.6875em; }\n  .svg-inline--fa.fa-w-12 {\n    width: 0.75em; }\n  .svg-inline--fa.fa-w-13 {\n    width: 0.8125em; }\n  .svg-inline--fa.fa-w-14 {\n    width: 0.875em; }\n  .svg-inline--fa.fa-w-15 {\n    width: 0.9375em; }\n  .svg-inline--fa.fa-w-16 {\n    width: 1em; }\n  .svg-inline--fa.fa-w-17 {\n    width: 1.0625em; }\n  .svg-inline--fa.fa-w-18 {\n    width: 1.125em; }\n  .svg-inline--fa.fa-w-19 {\n    width: 1.1875em; }\n  .svg-inline--fa.fa-w-20 {\n    width: 1.25em; }\n  .svg-inline--fa.fa-pull-left {\n    margin-right: .3em;\n    width: auto; }\n  .svg-inline--fa.fa-pull-right {\n    margin-left: .3em;\n    width: auto; }\n  .svg-inline--fa.fa-border {\n    height: 1.5em; }\n  .svg-inline--fa.fa-li {\n    width: 2em; }\n  .svg-inline--fa.fa-fw {\n    width: 1.25em; }\n\n.fa-layers svg.svg-inline--fa {\n  bottom: 0;\n  left: 0;\n  margin: auto;\n  position: absolute;\n  right: 0;\n  top: 0; }\n\n.fa-layers {\n  display: inline-block;\n  height: 1em;\n  position: relative;\n  text-align: center;\n  vertical-align: -.125em;\n  width: 1em; }\n  .fa-layers svg.svg-inline--fa {\n    -webkit-transform-origin: center center;\n            transform-origin: center center; }\n\n.fa-layers-text, .fa-layers-counter {\n  display: inline-block;\n  position: absolute;\n  text-align: center; }\n\n.fa-layers-text {\n  left: 50%;\n  top: 50%;\n  -webkit-transform: translate(-50%, -50%);\n          transform: translate(-50%, -50%);\n  -webkit-transform-origin: center center;\n          transform-origin: center center; }\n\n.fa-layers-counter {\n  background-color: #ff253a;\n  border-radius: 1em;\n  -webkit-box-sizing: border-box;\n          box-sizing: border-box;\n  color: #fff;\n  height: 1.5em;\n  line-height: 1;\n  max-width: 5em;\n  min-width: 1.5em;\n  overflow: hidden;\n  padding: .25em;\n  right: 0;\n  text-overflow: ellipsis;\n  top: 0;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: top right;\n          transform-origin: top right; }\n\n.fa-layers-bottom-right {\n  bottom: 0;\n  right: 0;\n  top: auto;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: bottom right;\n          transform-origin: bottom right; }\n\n.fa-layers-bottom-left {\n  bottom: 0;\n  left: 0;\n  right: auto;\n  top: auto;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: bottom left;\n          transform-origin: bottom left; }\n\n.fa-layers-top-right {\n  right: 0;\n  top: 0;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: top right;\n          transform-origin: top right; }\n\n.fa-layers-top-left {\n  left: 0;\n  right: auto;\n  top: 0;\n  -webkit-transform: scale(0.25);\n          transform: scale(0.25);\n  -webkit-transform-origin: top left;\n          transform-origin: top left; }\n\n.fa-lg {\n  font-size: 1.33333em;\n  line-height: 0.75em;\n  vertical-align: -.0667em; }\n\n.fa-xs {\n  font-size: .75em; }\n\n.fa-sm {\n  font-size: .875em; }\n\n.fa-1x {\n  font-size: 1em; }\n\n.fa-2x {\n  font-size: 2em; }\n\n.fa-3x {\n  font-size: 3em; }\n\n.fa-4x {\n  font-size: 4em; }\n\n.fa-5x {\n  font-size: 5em; }\n\n.fa-6x {\n  font-size: 6em; }\n\n.fa-7x {\n  font-size: 7em; }\n\n.fa-8x {\n  font-size: 8em; }\n\n.fa-9x {\n  font-size: 9em; }\n\n.fa-10x {\n  font-size: 10em; }\n\n.fa-fw {\n  text-align: center;\n  width: 1.25em; }\n\n.fa-ul {\n  list-style-type: none;\n  margin-left: 2.5em;\n  padding-left: 0; }\n  .fa-ul > li {\n    position: relative; }\n\n.fa-li {\n  left: -2em;\n  position: absolute;\n  text-align: center;\n  width: 2em;\n  line-height: inherit; }\n\n.fa-border {\n  border: solid 0.08em #eee;\n  border-radius: .1em;\n  padding: .2em .25em .15em; }\n\n.fa-pull-left {\n  float: left; }\n\n.fa-pull-right {\n  float: right; }\n\n.fa.fa-pull-left,\n.fas.fa-pull-left,\n.far.fa-pull-left,\n.fal.fa-pull-left,\n.fab.fa-pull-left {\n  margin-right: .3em; }\n\n.fa.fa-pull-right,\n.fas.fa-pull-right,\n.far.fa-pull-right,\n.fal.fa-pull-right,\n.fab.fa-pull-right {\n  margin-left: .3em; }\n\n.fa-spin {\n  -webkit-animation: fa-spin 2s infinite linear;\n          animation: fa-spin 2s infinite linear; }\n\n.fa-pulse {\n  -webkit-animation: fa-spin 1s infinite steps(8);\n          animation: fa-spin 1s infinite steps(8); }\n\n@-webkit-keyframes fa-spin {\n  0% {\n    -webkit-transform: rotate(0deg);\n            transform: rotate(0deg); }\n  100% {\n    -webkit-transform: rotate(360deg);\n            transform: rotate(360deg); } }\n\n@keyframes fa-spin {\n  0% {\n    -webkit-transform: rotate(0deg);\n            transform: rotate(0deg); }\n  100% {\n    -webkit-transform: rotate(360deg);\n            transform: rotate(360deg); } }\n\n.fa-rotate-90 {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=1)\";\n  -webkit-transform: rotate(90deg);\n          transform: rotate(90deg); }\n\n.fa-rotate-180 {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2)\";\n  -webkit-transform: rotate(180deg);\n          transform: rotate(180deg); }\n\n.fa-rotate-270 {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=3)\";\n  -webkit-transform: rotate(270deg);\n          transform: rotate(270deg); }\n\n.fa-flip-horizontal {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=0, mirror=1)\";\n  -webkit-transform: scale(-1, 1);\n          transform: scale(-1, 1); }\n\n.fa-flip-vertical {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2, mirror=1)\";\n  -webkit-transform: scale(1, -1);\n          transform: scale(1, -1); }\n\n.fa-flip-horizontal.fa-flip-vertical {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2, mirror=1)\";\n  -webkit-transform: scale(-1, -1);\n          transform: scale(-1, -1); }\n\n:root .fa-rotate-90,\n:root .fa-rotate-180,\n:root .fa-rotate-270,\n:root .fa-flip-horizontal,\n:root .fa-flip-vertical {\n  -webkit-filter: none;\n          filter: none; }\n\n.fa-stack {\n  display: inline-block;\n  height: 2em;\n  position: relative;\n  width: 2.5em; }\n\n.fa-stack-1x,\n.fa-stack-2x {\n  bottom: 0;\n  left: 0;\n  margin: auto;\n  position: absolute;\n  right: 0;\n  top: 0; }\n\n.svg-inline--fa.fa-stack-1x {\n  height: 1em;\n  width: 1.25em; }\n\n.svg-inline--fa.fa-stack-2x {\n  height: 2em;\n  width: 2.5em; }\n\n.fa-inverse {\n  color: #fff; }\n\n.sr-only {\n  border: 0;\n  clip: rect(0, 0, 0, 0);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  width: 1px; }\n\n.sr-only-focusable:active, .sr-only-focusable:focus {\n  clip: auto;\n  height: auto;\n  margin: 0;\n  overflow: visible;\n  position: static;\n  width: auto; }\n";

var css = function () {
  var dfp = DEFAULT_FAMILY_PREFIX;
  var drc = DEFAULT_REPLACEMENT_CLASS;
  var fp = config.familyPrefix;
  var rc = config.replacementClass;
  var s = baseStyles;

  if (fp !== dfp || rc !== drc) {
    var dPatt = new RegExp('\\.' + dfp + '\\-', 'g');
    var rPatt = new RegExp('\\.' + drc, 'g');

    s = s.replace(dPatt, '.' + fp + '-').replace(rPatt, '.' + rc);
  }

  return s;
};

function define(prefix, icons) {
  var normalized = Object.keys(icons).reduce(function (acc, iconName) {
    var icon = icons[iconName];
    var expanded = !!icon.icon;

    if (expanded) {
      acc[icon.iconName] = icon.icon;
    } else {
      acc[iconName] = icon;
    }
    return acc;
  }, {});

  if (typeof namespace.hooks.addPack === 'function') {
    namespace.hooks.addPack(prefix, normalized);
  } else {
    namespace.styles[prefix] = _extends({}, namespace.styles[prefix] || {}, normalized);
  }

  /**
   * Font Awesome 4 used the prefix of `fa` for all icons. With the introduction
   * of new styles we needed to differentiate between them. Prefix `fa` is now an alias
   * for `fas` so we'll easy the upgrade process for our users by automatically defining
   * this as well.
   */
  if (prefix === 'fas') {
    define('fa', icons);
  }
}

var Library = function () {
  function Library() {
    classCallCheck(this, Library);

    this.definitions = {};
  }

  createClass(Library, [{
    key: 'add',
    value: function add() {
      var _this = this;

      for (var _len = arguments.length, definitions = Array(_len), _key = 0; _key < _len; _key++) {
        definitions[_key] = arguments[_key];
      }

      var additions = definitions.reduce(this._pullDefinitions, {});

      Object.keys(additions).forEach(function (key) {
        _this.definitions[key] = _extends({}, _this.definitions[key] || {}, additions[key]);
        define(key, additions[key]);
        build();
      });
    }
  }, {
    key: 'reset',
    value: function reset() {
      this.definitions = {};
    }
  }, {
    key: '_pullDefinitions',
    value: function _pullDefinitions(additions, definition) {
      var normalized = definition.prefix && definition.iconName && definition.icon ? { 0: definition } : definition;

      Object.keys(normalized).map(function (key) {
        var _normalized$key = normalized[key],
            prefix = _normalized$key.prefix,
            iconName = _normalized$key.iconName,
            icon = _normalized$key.icon;


        if (!additions[prefix]) additions[prefix] = {};

        additions[prefix][iconName] = icon;
      });

      return additions;
    }
  }]);
  return Library;
}();

function prepIcon(icon) {
  var width = icon[0];
  var height = icon[1];
  var vectorData = icon.slice(4);

  return {
    found: true,
    width: width,
    height: height,
    icon: { tag: 'path', attributes: { fill: 'currentColor', d: vectorData[0] } }
  };
}

function ensureCss() {
  if (config.autoAddCss && !_cssInserted) {
    insertCss(css());
    _cssInserted = true;
  }
}

function apiObject(val, abstractCreator) {
  Object.defineProperty(val, 'abstract', {
    get: abstractCreator
  });

  Object.defineProperty(val, 'html', {
    get: function get() {
      return val.abstract.map(function (a) {
        return toHtml(a);
      });
    }
  });

  Object.defineProperty(val, 'node', {
    get: function get() {
      if (!IS_DOM) return;

      var container = DOCUMENT.createElement('div');
      container.innerHTML = val.html;
      return container.children;
    }
  });

  return val;
}

function findIconDefinition(params) {
  var _params$prefix = params.prefix,
      prefix = _params$prefix === undefined ? 'fa' : _params$prefix,
      iconName = params.iconName;


  if (!iconName) return;

  return iconFromMapping(library.definitions, prefix, iconName) || iconFromMapping(namespace.styles, prefix, iconName);
}

function resolveIcons(next) {
  return function (maybeIconDefinition) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var iconDefinition = (maybeIconDefinition || {}).icon ? maybeIconDefinition : findIconDefinition(maybeIconDefinition || {});

    var mask = params.mask;


    if (mask) {
      mask = (mask || {}).icon ? mask : findIconDefinition(mask || {});
    }

    return next(iconDefinition, _extends({}, params, { mask: mask }));
  };
}

var library = new Library();

var _cssInserted = false;

var parse = {
  transform: function transform(transformString) {
    return parseTransformString(transformString);
  }
};

var icon = resolveIcons(function (iconDefinition) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _params$transform = params.transform,
      transform = _params$transform === undefined ? meaninglessTransform : _params$transform,
      _params$symbol = params.symbol,
      symbol = _params$symbol === undefined ? false : _params$symbol,
      _params$mask = params.mask,
      mask = _params$mask === undefined ? null : _params$mask,
      _params$title = params.title,
      title = _params$title === undefined ? null : _params$title,
      _params$classes = params.classes,
      classes = _params$classes === undefined ? [] : _params$classes,
      _params$attributes = params.attributes,
      attributes = _params$attributes === undefined ? {} : _params$attributes,
      _params$styles = params.styles,
      styles = _params$styles === undefined ? {} : _params$styles;


  if (!iconDefinition) return;

  var prefix = iconDefinition.prefix,
      iconName = iconDefinition.iconName,
      icon = iconDefinition.icon;


  return apiObject(_extends({ type: 'icon' }, iconDefinition), function () {
    ensureCss();

    if (config.autoA11y) {
      if (title) {
        attributes['aria-labelledby'] = config.replacementClass + '-title-' + nextUniqueId();
      } else {
        attributes['aria-hidden'] = 'true';
      }
    }

    return makeInlineSvgAbstract({
      icons: {
        main: prepIcon(icon),
        mask: mask ? prepIcon(mask.icon) : { found: false, width: null, height: null, icon: {} }
      },
      prefix: prefix,
      iconName: iconName,
      transform: _extends({}, meaninglessTransform, transform),
      symbol: symbol,
      title: title,
      extra: {
        attributes: attributes,
        styles: styles,
        classes: classes
      }
    });
  });
});

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var humps = createCommonjsModule(function (module) {
(function(global) {

  var _processKeys = function(convert, obj, options) {
    if(!_isObject(obj) || _isDate(obj) || _isRegExp(obj) || _isBoolean(obj) || _isFunction(obj)) {
      return obj;
    }

    var output,
        i = 0,
        l = 0;

    if(_isArray(obj)) {
      output = [];
      for(l=obj.length; i<l; i++) {
        output.push(_processKeys(convert, obj[i], options));
      }
    }
    else {
      output = {};
      for(var key in obj) {
        if(Object.prototype.hasOwnProperty.call(obj, key)) {
          output[convert(key, options)] = _processKeys(convert, obj[key], options);
        }
      }
    }
    return output;
  };

  // String conversion methods

  var separateWords = function(string, options) {
    options = options || {};
    var separator = options.separator || '_';
    var split = options.split || /(?=[A-Z])/;

    return string.split(split).join(separator);
  };

  var camelize = function(string) {
    if (_isNumerical(string)) {
      return string;
    }
    string = string.replace(/[\-_\s]+(.)?/g, function(match, chr) {
      return chr ? chr.toUpperCase() : '';
    });
    // Ensure 1st char is always lowercase
    return string.substr(0, 1).toLowerCase() + string.substr(1);
  };

  var pascalize = function(string) {
    var camelized = camelize(string);
    // Ensure 1st char is always uppercase
    return camelized.substr(0, 1).toUpperCase() + camelized.substr(1);
  };

  var decamelize = function(string, options) {
    return separateWords(string, options).toLowerCase();
  };

  // Utilities
  // Taken from Underscore.js

  var toString = Object.prototype.toString;

  var _isFunction = function(obj) {
    return typeof(obj) === 'function';
  };
  var _isObject = function(obj) {
    return obj === Object(obj);
  };
  var _isArray = function(obj) {
    return toString.call(obj) == '[object Array]';
  };
  var _isDate = function(obj) {
    return toString.call(obj) == '[object Date]';
  };
  var _isRegExp = function(obj) {
    return toString.call(obj) == '[object RegExp]';
  };
  var _isBoolean = function(obj) {
    return toString.call(obj) == '[object Boolean]';
  };

  // Performant way to determine if obj coerces to a number
  var _isNumerical = function(obj) {
    obj = obj - 0;
    return obj === obj;
  };

  // Sets up function which handles processing keys
  // allowing the convert function to be modified by a callback
  var _processor = function(convert, options) {
    var callback = options && 'process' in options ? options.process : options;

    if(typeof(callback) !== 'function') {
      return convert;
    }

    return function(string, options) {
      return callback(string, convert, options);
    }
  };

  var humps = {
    camelize: camelize,
    decamelize: decamelize,
    pascalize: pascalize,
    depascalize: decamelize,
    camelizeKeys: function(object, options) {
      return _processKeys(_processor(camelize, options), object);
    },
    decamelizeKeys: function(object, options) {
      return _processKeys(_processor(decamelize, options), object, options);
    },
    pascalizeKeys: function(object, options) {
      return _processKeys(_processor(pascalize, options), object);
    },
    depascalizeKeys: function () {
      return this.decamelizeKeys.apply(this, arguments);
    }
  };

  if (module.exports) {
    module.exports = humps;
  } else {
    global.humps = humps;
  }

})(commonjsGlobal);
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};

var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends$1 = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var toConsumableArray$1 = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

function capitalize(val) {
  return val.charAt(0).toUpperCase() + val.slice(1);
}

function styleToObject(style) {
  return style.split(';').map(function (s) {
    return s.trim();
  }).filter(function (s) {
    return s;
  }).reduce(function (acc, pair) {
    var i = pair.indexOf(':');
    var prop = humps.camelize(pair.slice(0, i));
    var value = pair.slice(i + 1).trim();

    prop.startsWith('webkit') ? acc[capitalize(prop)] = value : acc[prop] = value;

    return acc;
  }, {});
}

function convert(createElement, element) {
  var extraProps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (typeof element === 'string') {
    return element;
  }
  var children = (element.children || []).map(convert.bind(null, createElement));

  var mixins = Object.keys(element.attributes || {}).reduce(function (acc, key) {
    var val = element.attributes[key];

    switch (key) {
      case 'class':
        acc.attrs['className'] = val;
        delete element.attributes['class'];
        break;
      case 'style':
        acc.attrs['style'] = styleToObject(val);
        break;
      default:
        if (key.indexOf('aria-') === 0 || key.indexOf('data-') === 0) {
          acc.attrs[key.toLowerCase()] = val;
        } else {
          acc.attrs[humps.camelize(key)] = val;
        }
    }

    return acc;
  }, { attrs: {} });

  var _extraProps$style = extraProps.style,
      existingStyle = _extraProps$style === undefined ? {} : _extraProps$style,
      remaining = objectWithoutProperties(extraProps, ['style']);


  mixins.attrs['style'] = _extends$1({}, mixins.attrs['style'], existingStyle);

  return createElement.apply(undefined, [element.tag, _extends$1({}, mixins.attrs, remaining)].concat(toConsumableArray$1(children)));
}

var PRODUCTION$1 = false;

try {
  PRODUCTION$1 = process.env.NODE_ENV === 'production';
} catch (e) {}

function log () {
  if (!PRODUCTION$1 && console && typeof console.error === 'function') {
    var _console;

    (_console = console).error.apply(_console, arguments);
  }
}

function objectWithKey(key, value) {
  return Array.isArray(value) && value.length > 0 || !Array.isArray(value) && value ? defineProperty({}, key, value) : {};
}

function classList(props) {
  var _classes;

  var classes = (_classes = {
    'fa-spin': props.spin,
    'fa-pulse': props.pulse,
    'fa-fw': props.fixedWidth,
    'fa-inverse': props.inverse,
    'fa-border': props.border,
    'fa-li': props.listItem,
    'fa-flip-horizontal': props.flip === 'horizontal' || props.flip === 'both',
    'fa-flip-vertical': props.flip === 'vertical' || props.flip === 'both'
  }, defineProperty(_classes, 'fa-' + props.size, props.size !== null), defineProperty(_classes, 'fa-rotate-' + props.rotation, props.rotation !== null), defineProperty(_classes, 'fa-pull-' + props.pull, props.pull !== null), _classes);

  return Object.keys(classes).map(function (key) {
    return classes[key] ? key : null;
  }).filter(function (key) {
    return key;
  });
}

function normalizeIconArgs(icon$$1) {
  if (icon$$1 === null) {
    return null;
  }

  if ((typeof icon$$1 === 'undefined' ? 'undefined' : _typeof(icon$$1)) === 'object' && icon$$1.prefix && icon$$1.iconName) {
    return icon$$1;
  }

  if (Array.isArray(icon$$1) && icon$$1.length === 2) {
    return { prefix: icon$$1[0], iconName: icon$$1[1] };
  }

  if (typeof icon$$1 === 'string') {
    return { prefix: 'fas', iconName: icon$$1 };
  }
}

function FontAwesomeIcon(props) {
  var iconArgs = props.icon,
      maskArgs = props.mask,
      symbol = props.symbol,
      className = props.className,
      title = props.title;


  var iconLookup = normalizeIconArgs(iconArgs);
  var classes = objectWithKey('classes', [].concat(toConsumableArray$1(classList(props)), toConsumableArray$1(className.split(' '))));
  var transform = objectWithKey('transform', typeof props.transform === 'string' ? parse.transform(props.transform) : props.transform);
  var mask = objectWithKey('mask', normalizeIconArgs(maskArgs));

  var renderedIcon = icon(iconLookup, _extends$1({}, classes, transform, mask, {
    symbol: symbol,
    title: title
  }));

  if (!renderedIcon) {
    log('Could not find icon', iconLookup);
    return null;
  }

  var abstract = renderedIcon.abstract;

  var extraProps = {};

  Object.keys(props).forEach(function (key) {
    if (!FontAwesomeIcon.defaultProps.hasOwnProperty(key)) {
      extraProps[key] = props[key];
    }
  });

  return convertCurry(abstract[0], extraProps);
}

FontAwesomeIcon.displayName = 'FontAwesomeIcon';

FontAwesomeIcon.propTypes = {
  border: PropTypes.bool,

  className: PropTypes.string,

  mask: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),

  fixedWidth: PropTypes.bool,

  inverse: PropTypes.bool,

  flip: PropTypes.oneOf(['horizontal', 'vertical', 'both']),

  icon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),

  listItem: PropTypes.bool,

  pull: PropTypes.oneOf(['right', 'left']),

  pulse: PropTypes.bool,

  rotation: PropTypes.oneOf([90, 180, 270]),

  size: PropTypes.oneOf(['lg', 'xs', 'sm', '1x', '2x', '3x', '4x', '5x', '6x', '7x', '8x', '9x', '10x']),

  spin: PropTypes.bool,

  symbol: PropTypes.oneOfType([PropTypes.bool, PropTypes.string]),

  title: PropTypes.string,

  transform: PropTypes.oneOfType([PropTypes.string, PropTypes.object])
};

FontAwesomeIcon.defaultProps = {
  border: false,
  className: '',
  mask: null,
  fixedWidth: false,
  inverse: false,
  flip: null,
  icon: null,
  listItem: false,
  pull: null,
  pulse: false,
  rotation: null,
  size: null,
  spin: false,
  symbol: false,
  title: '',
  transform: null
};

var convertCurry = convert.bind(null, React__default.createElement);

/*!
 * Font Awesome Pro 5.5.0 by @fontawesome - https://fontawesome.com
 * License - https://fontawesome.com/license (Commercial License)
 */
var faAngleDown = { prefix: 'fal', iconName: 'angle-down', icon: [256, 512, [], "f107", "M119.5 326.9L3.5 209.1c-4.7-4.7-4.7-12.3 0-17l7.1-7.1c4.7-4.7 12.3-4.7 17 0L128 287.3l100.4-102.2c4.7-4.7 12.3-4.7 17 0l7.1 7.1c4.7 4.7 4.7 12.3 0 17L136.5 327c-4.7 4.6-12.3 4.6-17-.1z"] };
var faAngleLeft = { prefix: 'fal', iconName: 'angle-left', icon: [192, 512, [], "f104", "M25.1 247.5l117.8-116c4.7-4.7 12.3-4.7 17 0l7.1 7.1c4.7 4.7 4.7 12.3 0 17L64.7 256l102.2 100.4c4.7 4.7 4.7 12.3 0 17l-7.1 7.1c-4.7 4.7-12.3 4.7-17 0L25 264.5c-4.6-4.7-4.6-12.3.1-17z"] };
var faAngleRight = { prefix: 'fal', iconName: 'angle-right', icon: [192, 512, [], "f105", "M166.9 264.5l-117.8 116c-4.7 4.7-12.3 4.7-17 0l-7.1-7.1c-4.7-4.7-4.7-12.3 0-17L127.3 256 25.1 155.6c-4.7-4.7-4.7-12.3 0-17l7.1-7.1c4.7-4.7 12.3-4.7 17 0l117.8 116c4.6 4.7 4.6 12.3-.1 17z"] };
var faCheckSquare = { prefix: 'fal', iconName: 'check-square', icon: [448, 512, [], "f14a", "M400 32H48C21.49 32 0 53.49 0 80v352c0 26.51 21.49 48 48 48h352c26.51 0 48-21.49 48-48V80c0-26.51-21.49-48-48-48zm0 32c8.823 0 16 7.178 16 16v352c0 8.822-7.177 16-16 16H48c-8.822 0-16-7.178-16-16V80c0-8.822 7.178-16 16-16h352m-34.301 98.293l-8.451-8.52c-4.667-4.705-12.265-4.736-16.97-.068l-163.441 162.13-68.976-69.533c-4.667-4.705-12.265-4.736-16.97-.068l-8.52 8.451c-4.705 4.667-4.736 12.265-.068 16.97l85.878 86.572c4.667 4.705 12.265 4.736 16.97.068l180.48-179.032c4.704-4.667 4.735-12.265.068-16.97z"] };
var faSpinnerThird = { prefix: 'fal', iconName: 'spinner-third', icon: [512, 512, [], "f3f4", "M460.115 373.846l-6.941-4.008c-5.546-3.202-7.564-10.177-4.661-15.886 32.971-64.838 31.167-142.731-5.415-205.954-36.504-63.356-103.118-103.876-175.8-107.701C260.952 39.963 256 34.676 256 28.321v-8.012c0-6.904 5.808-12.337 12.703-11.982 83.552 4.306 160.157 50.861 202.106 123.67 42.069 72.703 44.083 162.322 6.034 236.838-3.14 6.149-10.75 8.462-16.728 5.011z"] };
var faSquare = { prefix: 'fal', iconName: 'square', icon: [448, 512, [], "f0c8", "M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48zm16 400c0 8.8-7.2 16-16 16H48c-8.8 0-16-7.2-16-16V80c0-8.8 7.2-16 16-16h352c8.8 0 16 7.2 16 16v352z"] };
var faTimes = { prefix: 'fal', iconName: 'times', icon: [320, 512, [], "f00d", "M193.94 256L296.5 153.44l21.15-21.15c3.12-3.12 3.12-8.19 0-11.31l-22.63-22.63c-3.12-3.12-8.19-3.12-11.31 0L160 222.06 36.29 98.34c-3.12-3.12-8.19-3.12-11.31 0L2.34 120.97c-3.12 3.12-3.12 8.19 0 11.31L126.06 256 2.34 379.71c-3.12 3.12-3.12 8.19 0 11.31l22.63 22.63c3.12 3.12 8.19 3.12 11.31 0L160 289.94 262.56 392.5l21.15 21.15c3.12 3.12 8.19 3.12 11.31 0l22.63-22.63c3.12-3.12 3.12-8.19 0-11.31L193.94 256z"] };

var colors = {
    buttonBackground: {
        purpleGradient: 'rgba(235,99,107,1)',
        pinkGradient: 'rgba(255,64,131,1)',
    },
    gray: {
        light: 'rgba(244, 244, 244, 1)',
        dark: 'rgba(102, 102, 102, 1)',
        text: 'rgba(111,129,138,1)',
        disabledBackground: 'rgb(232, 232, 232)',
        toggleBg: 'rgba(185,185,185,0.5)',
        toggleBall: 'rgba(232,232,232,1)',
        slideArrow: 'rgba(123, 139, 147, 1)',
    },
    red: {
        error: 'rgba(181, 60, 46, 1)',
    },
    blue: {
        main: 'rgba(81,81,229,1)',
        text: 'rgba(83,98,230,1)',
        light: 'rgba(100,222,233,1)',
        lightText: 'rgba(100,222,233,1)',
        modalHeader: 'rgb(80, 80, 230)',
        toggleBg: 'rgba(81,81,229,0.5)',
    },
};

var regularFont = 'Nunito';
var mainFont = 'Montserrat, sans-serif';

var setBackgroundColor = function (bgColor, outLined, disabled) {
    if (disabled && outLined) {
        return null;
    }
    if (disabled) {
        return colors.gray.disabledBackground;
    }
    if (bgColor && !outLined) {
        return bgColor;
    }
    return null;
};
var setTextColor = function (textColor, disabled) {
    if (disabled) {
        return colors.gray.text;
    }
    if (textColor) {
        return textColor;
    }
    return '#fff';
};
var StyledButton = styled__default.button(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  @supports (display: flex) {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n  }\n\n  position: relative;\n  border-radius: 50px;\n  padding: ", ";\n  border: 0;\n  background: ", ";\n  background-color: ", ";\n  border: ", ";\n  background-color: ", ";\n  background-repeat: no-repeat;\n  color: ", ";\n  cursor: ", ";\n  font-family: ", ";\n  font-size: 14px;\n  font-weight: 600;\n  width: ", ";\n  max-width: 320px;\n\n  &:focus {\n    outline: 0;\n  }\n"], ["\n  @supports (display: flex) {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n  }\n\n  position: relative;\n  border-radius: 50px;\n  padding: ", ";\n  border: 0;\n  background: ", ";\n  background-color: ",
    ";\n  border: ", ";\n  background-color: ",
    ";\n  background-repeat: no-repeat;\n  color: ",
    ";\n  cursor: ",
    ";\n  font-family: ", ";\n  font-size: 14px;\n  font-weight: 600;\n  width: ",
    ";\n  max-width: 320px;\n\n  &:focus {\n    outline: 0;\n  }\n"])), function (props) { return (props.options.outLined ? '13px 20px' : '15px 20px'); }, function (props) { return (props.options.outLined ? 'transparent' : null); }, function (props) {
    return !props.options.outLined && !props.options.bgColor && !props.options.disabled
        ? "#eb6b6c"
        : null;
}, function (props) { return (props.options.outLined ? '2px solid' : null); }, function (props) {
    return setBackgroundColor(props.options.bgColor, props.options.outLined, props.options.disabled);
}, function (props) {
    return setTextColor(props.options.textColor, props.options.disabled);
}, function (props) {
    return props.options.loading || props.options.disabled ? 'default' : 'pointer';
}, mainFont, function (props) {
    return props.options.icon && !props.options.label ? '50px' : '100%';
});
var loadingSpin = styled.keyframes(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  from {transform:rotate(0deg);}\n  to {transform:rotate(360deg);}\n"], ["\n  from {transform:rotate(0deg);}\n  to {transform:rotate(360deg);}\n"])));
var ExtendedIconContainer = styled__default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  position: ", ";\n  left: ", ";\n  animation: ", ";\n"], ["\n  position: ",
    ";\n  left: ",
    ";\n  animation: ",
    ";\n"])), function (props) {
    return (props.options.icon || props.options.loading) && props.options.label
        ? 'absolute'
        : 'initial';
}, function (props) {
    return (props.options.icon || props.options.loading) && props.options.label
        ? '15px'
        : null;
}, function (props) {
    return props.options.loading ? loadingSpin + " 1s infinite" : null;
});
var Button = function (props) {
    var label = props.label, onClick = props.onClick, icon = props.icon, bgColor = props.bgColor, outLined = props.outLined, textColor = props.textColor, children = props.children, type = props.type, disabled = props.disabled, loading = props.loading, rest = __rest(props, ["label", "onClick", "icon", "bgColor", "outLined", "textColor", "children", "type", "disabled", "loading"]);
    var renderButtonIcon = function () {
        if (loading) {
            return (React.createElement(ExtendedIconContainer, { options: { icon: icon, label: label, loading: loading } },
                React.createElement(FontAwesomeIcon, { icon: faSpinnerThird, color: textColor ? textColor : '#fff', size: "lg" })));
        }
        if (icon) {
            return (React.createElement(ExtendedIconContainer, { options: { icon: icon, label: label } }, icon));
        }
        return null;
    };
    return (React.createElement(StyledButton, __assign({ onClick: onClick, type: type, disabled: disabled || loading, options: { icon: icon, label: label, bgColor: bgColor, outLined: outLined, textColor: textColor, loading: loading, disabled: disabled } }, rest),
        renderButtonIcon(),
        children || label));
};
var templateObject_1, templateObject_2, templateObject_3;

var ButtonsContainer = styled__default.div(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n  display: flex;\n  > button {\n    border-radius: 0;\n\n    &:first-child {\n      border-top-left-radius: 50px;\n      border-bottom-left-radius: 50px;\n    }\n\n    &:last-child {\n      border-top-right-radius: 50px;\n      border-bottom-right-radius: 50px;\n    }\n  }\n"], ["\n  display: flex;\n  > button {\n    border-radius: 0;\n\n    &:first-child {\n      border-top-left-radius: 50px;\n      border-bottom-left-radius: 50px;\n    }\n\n    &:last-child {\n      border-top-right-radius: 50px;\n      border-bottom-right-radius: 50px;\n    }\n  }\n"])));
function ButtonGroup(_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    return React.createElement(ButtonsContainer, __assign({}, rest), children);
}
var templateObject_1$1;

var Fieldset = styled__default.fieldset(templateObject_1$2 || (templateObject_1$2 = __makeTemplateObject(["\n  border: none;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n\n  > legend {\n    height: 1px;\n    width: 1px;\n    ", ";\n  }\n"], ["\n  border: none;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n\n  > legend {\n    height: 1px;\n    width: 1px;\n    ",
    ";\n  }\n"])), function (props) {
    return props.options.hideLegend
        ? "\n    @supports (clip-path: circle(0%)) {\n      clip-path: circle(0%);\n    }\n    @supports not (clip-path: circle(0%)) {\n      clip: rect(0, 0, 0, 0);\n    }\n    "
        : '';
});
function FormGroup(_a) {
    var legend = _a.legend, children = _a.children, _b = _a.hideLegend, hideLegend = _b === void 0 ? true : _b, rest = __rest(_a, ["legend", "children", "hideLegend"]);
    return (React.createElement(Fieldset, __assign({ options: { hideLegend: hideLegend } }, rest),
        React.createElement("legend", null, legend),
        children));
}
FormGroup.defaultProps = {
    hideLegend: true,
};
var templateObject_1$2;

var Label = styled__default.label(templateObject_1$3 || (templateObject_1$3 = __makeTemplateObject(["\n  display: flex;\n  display: inline-table;\n  cursor: pointer;\n\n  input[type='radio'] {\n    height: 1px;\n    width: 1px;\n    margin: -1px;\n    padding: 0;\n    position: absolute;\n    @supports (clip-path: circle(0%)) {\n      clip-path: circle(0%);\n    }\n    @supports not (clip-path: circle(0%)) {\n      clip: rect(0, 0, 0, 0);\n    }\n  }\n\n  > span {\n    font-family: ", ";\n    font-size: 1rem;\n    font-weight: 400;\n    color: ", ";\n    white-space: nowrap;\n    display: flex;\n    align-items: center;\n\n    &:before {\n      content: '';\n      width: 6px;\n      height: 6px;\n      box-sizing: content-box;\n      display: inline-block;\n      margin-right: 16px;\n      border-radius: 100%;\n      border: 5px solid\n        ", ";\n      box-shadow: 0 0 0 0.15em\n        ", ";\n      background-color: ", ";\n\n      @media (min-width: 768px) {\n        border: 5px solid\n          ", ";\n        box-shadow: 0 0 0 0.15em\n          ", ";\n        background-color: ", ";\n        margin-right: 10px;\n      }\n    }\n  }\n\n  input[type='radio']:checked + span::before {\n    box-shadow: inset 0 0 0 1em ", ",\n      0 0 0 0.15em ", ";\n\n    @media (min-width: 768px) {\n      box-shadow: inset 0 0 0 1em\n          ", ",\n        0 0 0 0.15em ", ";\n    }\n  }\n"], ["\n  display: flex;\n  display: inline-table;\n  cursor: pointer;\n\n  input[type='radio'] {\n    height: 1px;\n    width: 1px;\n    margin: -1px;\n    padding: 0;\n    position: absolute;\n    @supports (clip-path: circle(0%)) {\n      clip-path: circle(0%);\n    }\n    @supports not (clip-path: circle(0%)) {\n      clip: rect(0, 0, 0, 0);\n    }\n  }\n\n  > span {\n    font-family: ", ";\n    font-size: 1rem;\n    font-weight: 400;\n    color: ",
    ";\n    white-space: nowrap;\n    display: flex;\n    align-items: center;\n\n    &:before {\n      content: '';\n      width: 6px;\n      height: 6px;\n      box-sizing: content-box;\n      display: inline-block;\n      margin-right: 16px;\n      border-radius: 100%;\n      border: 5px solid\n        ",
    ";\n      box-shadow: 0 0 0 0.15em\n        ",
    ";\n      background-color: ",
    ";\n\n      @media (min-width: 768px) {\n        border: 5px solid\n          ",
    ";\n        box-shadow: 0 0 0 0.15em\n          ",
    ";\n        background-color: ",
    ";\n        margin-right: 10px;\n      }\n    }\n  }\n\n  input[type='radio']:checked + span::before {\n    box-shadow: inset 0 0 0 1em ", ",\n      0 0 0 0.15em ", ";\n\n    @media (min-width: 768px) {\n      box-shadow: inset 0 0 0 1em\n          ", ",\n        0 0 0 0.15em ", ";\n    }\n  }\n"])), regularFont, function (props) {
    return props.options.negativeColor ? 'white' : colors.gray.text;
}, function (props) {
    return props.options.negativeColor
        ? props.options.bgColorDesktop
        : props.options.bgColor;
}, function (props) {
    return props.options.negativeColor
        ? props.options.outDefaultColorDesktop
        : props.options.outDefaultColor;
}, function (props) {
    return props.options.negativeColor
        ? props.options.bgColorDesktop
        : props.options.bgColor;
}, function (props) {
    return !props.options.negativeColor
        ? props.options.bgColorDesktop
        : props.options.bgColor;
}, function (props) {
    return !props.options.negativeColor
        ? props.options.outDefaultColorDesktop
        : props.options.outDefaultColor;
}, function (props) {
    return !props.options.negativeColor
        ? props.options.bgColorDesktop
        : props.options.bgColor;
}, function (props) { return props.options.outSelectedColor; }, function (props) { return props.options.outSelectedColor; }, function (props) { return props.options.outSelectedColorDesktop; }, function (props) { return props.options.outSelectedColorDesktop; });
function RadioButton(_a) {
    var label = _a.label, _b = _a.outDefaultColor, outDefaultColor = _b === void 0 ? colors.gray.text : _b, _c = _a.outSelectedColor, outSelectedColor = _c === void 0 ? colors.blue.main : _c, _d = _a.bgColor, bgColor = _d === void 0 ? 'white' : _d, _e = _a.outDefaultColorDesktop, outDefaultColorDesktop = _e === void 0 ? colors.gray.text : _e, _f = _a.outSelectedColorDesktop, outSelectedColorDesktop = _f === void 0 ? colors.blue.main : _f, _g = _a.bgColorDesktop, bgColorDesktop = _g === void 0 ? 'white' : _g, _h = _a.negativeColor, negativeColor = _h === void 0 ? false : _h, rest = __rest(_a, ["label", "outDefaultColor", "outSelectedColor", "bgColor", "outDefaultColorDesktop", "outSelectedColorDesktop", "bgColorDesktop", "negativeColor"]);
    return (React.createElement(Label, { options: {
            outDefaultColor: outDefaultColor,
            outSelectedColor: outSelectedColor,
            bgColor: bgColor,
            outDefaultColorDesktop: outDefaultColorDesktop,
            outSelectedColorDesktop: outSelectedColorDesktop,
            bgColorDesktop: bgColorDesktop,
            negativeColor: negativeColor,
        } },
        React.createElement("input", __assign({ type: "radio" }, rest)),
        React.createElement("span", null, label)));
}
var templateObject_1$3;

var Label$1 = styled__default.label(templateObject_1$4 || (templateObject_1$4 = __makeTemplateObject(["\n  color: white;\n  display: inline-table;\n  cursor: pointer;\n\n  > span {\n    display: flex;\n    align-items: center;\n    font-family: ", ";\n    font-size: 14px;\n    font-weight: 500;\n  }\n  .check-square-icon {\n    display: none;\n    width: 24px;\n    height: 24px;\n    /* transition: transform 0.2s ease-in-out; */\n  }\n  .square-icon {\n    display: inline-block;\n    width: 24px;\n    height: 24px;\n    /* transition: transform 0.2s ease-in-out; */\n  }\n  .label {\n    margin-left: 12px;\n  }\n\n  input[type='checkbox'] {\n    height: 1px;\n    width: 1px;\n    @supports (clip-path: circle(0%)) {\n      clip-path: circle(0%);\n    }\n\n    @supports not (clip-path: circle(0%)) {\n      clip: rect(0, 0, 0, 0);\n    }\n    margin: -1px;\n    padding: 0;\n    position: absolute;\n\n    &:checked + span .square-icon {\n      display: none;\n    }\n\n    &:checked + span .check-square-icon {\n      display: inline-block;\n    }\n\n    /* &:focus + span .square-icon {\n      transform: scale(1.1);\n    }\n\n    &:focus + span .check-square-icon {\n      transform: scale(1.1);\n    } */\n  }\n"], ["\n  color: white;\n  display: inline-table;\n  cursor: pointer;\n\n  > span {\n    display: flex;\n    align-items: center;\n    font-family: ", ";\n    font-size: 14px;\n    font-weight: 500;\n  }\n  .check-square-icon {\n    display: none;\n    width: 24px;\n    height: 24px;\n    /* transition: transform 0.2s ease-in-out; */\n  }\n  .square-icon {\n    display: inline-block;\n    width: 24px;\n    height: 24px;\n    /* transition: transform 0.2s ease-in-out; */\n  }\n  .label {\n    margin-left: 12px;\n  }\n\n  input[type='checkbox'] {\n    height: 1px;\n    width: 1px;\n    @supports (clip-path: circle(0%)) {\n      clip-path: circle(0%);\n    }\n\n    @supports not (clip-path: circle(0%)) {\n      clip: rect(0, 0, 0, 0);\n    }\n    margin: -1px;\n    padding: 0;\n    position: absolute;\n\n    &:checked + span .square-icon {\n      display: none;\n    }\n\n    &:checked + span .check-square-icon {\n      display: inline-block;\n    }\n\n    /* &:focus + span .square-icon {\n      transform: scale(1.1);\n    }\n\n    &:focus + span .check-square-icon {\n      transform: scale(1.1);\n    } */\n  }\n"])), regularFont);
function Checkbox(_a) {
    var label = _a.label, style = _a.style, rest = __rest(_a, ["label", "style"]);
    return (React.createElement(Label$1, { style: __assign({}, style) },
        React.createElement("input", __assign({ type: "checkbox" }, rest)),
        React.createElement("span", null,
            React.createElement("span", { className: "square-icon" },
                React.createElement(FontAwesomeIcon, { icon: faSquare, style: { width: '24px', height: '24px' } })),
            React.createElement("span", { className: "check-square-icon" },
                React.createElement(FontAwesomeIcon, { icon: faCheckSquare, style: { width: '24px', height: '24px' } })),
            React.createElement("span", { className: "label" }, label))));
}
var templateObject_1$4;

var Label$2 = styled__default.label(templateObject_1$5 || (templateObject_1$5 = __makeTemplateObject(["\n  display: inline-table;\n  cursor: pointer;\n\n  input[type='checkbox'] {\n    height: 1px;\n    width: 1px;\n    @supports (clip-path: circle(0%)) {\n      clip-path: circle(0%);\n    }\n\n    @supports not (clip-path: circle(0%)) {\n      clip: rect(0, 0, 0, 0);\n    }\n    margin: -1px;\n    padding: 0;\n    position: absolute;\n\n    & + .toggle {\n      width: 34px;\n      height: 14px;\n      background-color: ", ";\n      display: flex;\n      align-items: center;\n      border-radius: 10px;\n      transform: translate3d(0, 0, 0);\n      transition: all 0.2s ease-in-out;\n\n      .toggle-ball {\n        width: 20px;\n        height: 20px;\n        border-radius: 100%;\n        background-color: ", ";\n        display: flex;\n        transition: all 0.2s ease-in-out;\n      }\n    }\n\n    &:checked + .toggle {\n      background-color: ", ";\n      .toggle-ball {\n        background-color: ", ";\n        transform: translate3d(80%, 0, 0);\n      }\n    }\n\n    /* &:focus + span .toggle {\n      transform: scale(1.1);\n    }\n\n    &:focus + span .toggle {\n      transform: scale(1.1);\n    } */\n  }\n"], ["\n  display: inline-table;\n  cursor: pointer;\n\n  input[type='checkbox'] {\n    height: 1px;\n    width: 1px;\n    @supports (clip-path: circle(0%)) {\n      clip-path: circle(0%);\n    }\n\n    @supports not (clip-path: circle(0%)) {\n      clip: rect(0, 0, 0, 0);\n    }\n    margin: -1px;\n    padding: 0;\n    position: absolute;\n\n    & + .toggle {\n      width: 34px;\n      height: 14px;\n      background-color: ", ";\n      display: flex;\n      align-items: center;\n      border-radius: 10px;\n      transform: translate3d(0, 0, 0);\n      transition: all 0.2s ease-in-out;\n\n      .toggle-ball {\n        width: 20px;\n        height: 20px;\n        border-radius: 100%;\n        background-color: ", ";\n        display: flex;\n        transition: all 0.2s ease-in-out;\n      }\n    }\n\n    &:checked + .toggle {\n      background-color: ", ";\n      .toggle-ball {\n        background-color: ", ";\n        transform: translate3d(80%, 0, 0);\n      }\n    }\n\n    /* &:focus + span .toggle {\n      transform: scale(1.1);\n    }\n\n    &:focus + span .toggle {\n      transform: scale(1.1);\n    } */\n  }\n"])), function (props) { return props.options.bgColor; }, function (props) { return props.options.ballColor; }, function (props) { return props.options.bgActiveColor; }, function (props) { return props.options.ballActiveColor; });
function Checkbox$1(_a) {
    var style = _a.style, _b = _a.bgColor, bgColor = _b === void 0 ? colors.gray.toggleBg : _b, _c = _a.ballColor, ballColor = _c === void 0 ? colors.gray.toggleBall : _c, _d = _a.bgActiveColor, bgActiveColor = _d === void 0 ? colors.blue.toggleBg : _d, _e = _a.ballActiveColor, ballActiveColor = _e === void 0 ? colors.blue.main : _e, rest = __rest(_a, ["style", "bgColor", "ballColor", "bgActiveColor", "ballActiveColor"]);
    return (React.createElement(Label$2, { style: __assign({}, style), options: { bgColor: bgColor, ballColor: ballColor, bgActiveColor: bgActiveColor, ballActiveColor: ballActiveColor } },
        React.createElement("input", __assign({ type: "checkbox" }, rest)),
        React.createElement("span", { className: "toggle" },
            React.createElement("span", { className: "toggle-ball" }))));
}
var templateObject_1$5;

var GlobalInputContainer = styled__default.div(templateObject_1$6 || (templateObject_1$6 = __makeTemplateObject(["\n  display: flex;\n  margin-top: 5px;\n"], ["\n  display: flex;\n  margin-top: 5px;\n"])));
var LabelInput = styled__default.label(templateObject_2$1 || (templateObject_2$1 = __makeTemplateObject(["\n  font-size: 12px;\n  font-family: ", ";\n  letter-spacing: 1.6px;\n  text-transform: uppercase;\n  font-weight: 500;\n  margin-left: 5px;\n  color: ", ";\n"], ["\n  font-size: 12px;\n  font-family: ", ";\n  letter-spacing: 1.6px;\n  text-transform: uppercase;\n  font-weight: 500;\n  margin-left: 5px;\n  color: ",
    ";\n"])), regularFont, function (props) {
    return props.options.labelColor ? props.options.labelColor : '#ffffff';
});
var ExtendedTextArea = styled__default.textarea(templateObject_3$1 || (templateObject_3$1 = __makeTemplateObject(["\n  border: 1px solid ", ";\n  font-size: 14px;\n  width: 300px;\n  padding: 10px 10px 10px 15px;\n  border-radius: 20px;\n  font-family: ", ";\n  color: ", ";\n  overflow: hidden;\n\n  &:focus {\n    outline: 0;\n  }\n"], ["\n  border: 1px solid ", ";\n  font-size: 14px;\n  width: 300px;\n  padding: 10px 10px 10px 15px;\n  border-radius: 20px;\n  font-family: ", ";\n  color: ", ";\n  overflow: hidden;\n\n  &:focus {\n    outline: 0;\n  }\n"])), colors.gray.light, regularFont, colors.gray.dark);
var ErrorTextStyle = styled__default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  font-family: 'Nunito';\n  font-size: 0.75rem;\n  color: ", ";\n  margin: 5px 0px 10px 0px;\n"], ["\n  font-family: 'Nunito';\n  font-size: 0.75rem;\n  color: ",
    ";\n  margin: 5px 0px 10px 0px;\n"])), function (props) {
    return props.options.textErrorColor
        ? props.options.textErrorColor
        : colors.red.error;
});
var TextArea = function (props) {
    var placeholder = props.placeholder, label = props.label, labelColor = props.labelColor, style = props.style, name = props.name, rows = props.rows, cols = props.cols, textErrorColor = props.textErrorColor, field = props.field, form = props.form, rest = __rest(props, ["placeholder", "label", "labelColor", "style", "name", "rows", "cols", "textErrorColor", "field", "form"]);
    return (React.createElement("div", { style: style },
        label ? React.createElement(LabelInput, { options: { labelColor: labelColor } }, label) : null,
        React.createElement(GlobalInputContainer, null,
            React.createElement(ExtendedTextArea, __assign({ placeholder: placeholder, name: name, rows: rows, cols: cols }, field, rest))),
        form && field && form.errors && field.name
            ? form.errors[field.name] && (React.createElement(ErrorTextStyle, { options: { textErrorColor: textErrorColor } }, form.errors[field.name]))
            : null));
};
TextArea.defaultProps = {
    type: 'text',
    placeholder: null,
    labelColor: '',
    style: {},
};
var templateObject_1$6, templateObject_2$1, templateObject_3$1, templateObject_4;

var GlobalInputContainer$1 = styled__default.div(templateObject_1$7 || (templateObject_1$7 = __makeTemplateObject(["\n  display: flex;\n  margin-top: 5px;\n"], ["\n  display: flex;\n  margin-top: 5px;\n"])));
var LabelInput$1 = styled__default.label(templateObject_2$2 || (templateObject_2$2 = __makeTemplateObject(["\n  font-size: 12px;\n  font-family: ", ";\n  text-transform: uppercase;\n  font-weight: 500;\n  margin-left: 5px;\n  letter-spacing: 1.6px;\n  color: ", ";\n"], ["\n  font-size: 12px;\n  font-family: ", ";\n  text-transform: uppercase;\n  font-weight: 500;\n  margin-left: 5px;\n  letter-spacing: 1.6px;\n  color: ",
    ";\n"])), regularFont, function (props) {
    return props.options.labelColor ? props.options.labelColor : '#ffffff';
});
var IconContainer = styled__default.div(templateObject_3$2 || (templateObject_3$2 = __makeTemplateObject(["\n  width: 40px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border: 1px solid ", ";\n  border-radius: 50px 0px 0px 50px;\n  background-color: ", ";\n"], ["\n  width: 40px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border: 1px solid ", ";\n  border-radius: 50px 0px 0px 50px;\n  background-color: ", ";\n"])), colors.gray.light, colors.gray.light);
var ExtendedInput = styled__default.input(templateObject_4$1 || (templateObject_4$1 = __makeTemplateObject(["\n  border: 1px solid ", ";\n  width: ", ";\n  padding: ", ";\n  border-radius: ", ";\n  font-size: 14px;\n  font-family: ", ";\n  color: ", ";\n  margin: 0;\n\n  &:focus {\n    outline: 0;\n  }\n"], ["\n  border: 1px solid ", ";\n  width: ", ";\n  padding: ", ";\n  border-radius: ",
    ";\n  font-size: 14px;\n  font-family: ", ";\n  color: ", ";\n  margin: 0;\n\n  &:focus {\n    outline: 0;\n  }\n"])), colors.gray.light, function (props) { return (props.options.icon ? '260px' : '300px'); }, function (props) { return (props.options.icon ? '10px' : '10px 10px 10px 15px'); }, function (props) {
    return props.options.icon ? '0px 50px 50px 0px' : '50px';
}, regularFont, colors.gray.dark);
var ErrorTextStyle$1 = styled__default.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  font-family: 'Nunito';\n  font-size: 0.75rem;\n  margin: 5px 0px 10px 0px;\n  color: ", ";\n"], ["\n  font-family: 'Nunito';\n  font-size: 0.75rem;\n  margin: 5px 0px 10px 0px;\n  color: ",
    ";\n"])), function (props) {
    return props.options.textErrorColor
        ? props.options.textErrorColor
        : colors.red.error;
});
var TextInput = function (props) {
    var label = props.label, name = props.name, textErrorColor = props.textErrorColor, field = props.field, form = props.form, placeholder = props.placeholder, icon = props.icon, style = props.style, _a = props.type, type = _a === void 0 ? 'text' : _a, _b = props.labelColor, labelColor = _b === void 0 ? '' : _b, rest = __rest(props, ["label", "name", "textErrorColor", "field", "form", "placeholder", "icon", "style", "type", "labelColor"]);
    return (React.createElement("div", { style: style },
        React.createElement(LabelInput$1, { options: { labelColor: labelColor } }, label),
        React.createElement(GlobalInputContainer$1, null,
            icon ? (React.createElement(IconContainer, null,
                React.createElement(FontAwesomeIcon, { icon: icon, color: colors.gray.dark }))) : null,
            React.createElement(ExtendedInput, __assign({ type: type, placeholder: placeholder, name: name, options: { icon: icon } }, field, rest))),
        form && field && form.errors && form.touched && field.name
            ? form.errors[field.name] &&
                form.touched[field.name] && (React.createElement(ErrorTextStyle$1, { options: { textErrorColor: textErrorColor } }, form.errors[field.name]))
            : null));
};
var templateObject_1$7, templateObject_2$2, templateObject_3$2, templateObject_4$1, templateObject_5;

var Label$3 = styled__default.label(templateObject_1$8 || (templateObject_1$8 = __makeTemplateObject(["\n  margin-top: 25px;\n  width: 100%;\n  font-family: ", ";\n  position: relative;\n\n  .focused {\n    transform: translate3d(0, -30px, 0);\n    font-size: 10px;\n  }\n\n  span {\n    color: rgba(255, 255, 255, 0.5);\n    text-transform: uppercase;\n    font-size: 12px;\n    position: absolute;\n    bottom: 0;\n    left: 0;\n    transition: 0.3s;\n  }\n\n  input {\n    width: 100%;\n    border: none;\n    background: transparent;\n    border-bottom: 1px solid rgba(255, 255, 255, 0.5);\n    padding-bottom: 5px;\n    font-weight: 600;\n    color: white;\n    font-size: 14px;\n    font-family: ", ";\n  }\n"], ["\n  margin-top: 25px;\n  width: 100%;\n  font-family: ", ";\n  position: relative;\n\n  .focused {\n    transform: translate3d(0, -30px, 0);\n    font-size: 10px;\n  }\n\n  span {\n    color: rgba(255, 255, 255, 0.5);\n    text-transform: uppercase;\n    font-size: 12px;\n    position: absolute;\n    bottom: 0;\n    left: 0;\n    transition: 0.3s;\n  }\n\n  input {\n    width: 100%;\n    border: none;\n    background: transparent;\n    border-bottom: 1px solid rgba(255, 255, 255, 0.5);\n    padding-bottom: 5px;\n    font-weight: 600;\n    color: white;\n    font-size: 14px;\n    font-family: ", ";\n  }\n"])), regularFont, regularFont);
var UnderlineTextField = /** @class */ (function (_super) {
    __extends(UnderlineTextField, _super);
    function UnderlineTextField() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            focused: false,
        };
        _this.onFocus = function (rest) { return function (e) {
            _this.setState({ focused: true });
            if (rest && rest.onFocus) {
                rest.onFocus(e);
            }
        }; };
        _this.onBlur = function (rest) { return function (e) {
            if (!e.currentTarget.value) {
                _this.setState({ focused: false });
            }
            if (rest && rest.onBlur) {
                rest.onBlur(e);
            }
        }; };
        return _this;
    }
    UnderlineTextField.prototype.render = function () {
        var _a = this.props, label = _a.label, rest = __rest(_a, ["label"]);
        var focused = this.state.focused;
        return (React.createElement(Label$3, null,
            React.createElement("input", __assign({}, rest, { onFocus: this.onFocus(rest), onBlur: this.onBlur(rest) })),
            React.createElement("span", { className: focused || rest.value ? 'focused' : '' }, label)));
    };
    return UnderlineTextField;
}(React.Component));
var templateObject_1$8;

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
}

function createCommonjsModule$1(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var tabbable_1 = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findTabbableDescendants;
/*!
 * Adapted from jQuery UI core
 *
 * http://jqueryui.com
 *
 * Copyright 2014 jQuery Foundation and other contributors
 * Released under the MIT license.
 * http://jquery.org/license
 *
 * http://api.jqueryui.com/category/ui-core/
 */

var tabbableNode = /input|select|textarea|button|object/;

function hidesContents(element) {
  var zeroSize = element.offsetWidth <= 0 && element.offsetHeight <= 0;

  // If the node is empty, this is good enough
  if (zeroSize && !element.innerHTML) return true;

  // Otherwise we need to check some styles
  var style = window.getComputedStyle(element);
  return zeroSize ? style.getPropertyValue("overflow") !== "visible" : style.getPropertyValue("display") == "none";
}

function visible(element) {
  var parentElement = element;
  while (parentElement) {
    if (parentElement === document.body) break;
    if (hidesContents(parentElement)) return false;
    parentElement = parentElement.parentNode;
  }
  return true;
}

function focusable(element, isTabIndexNotNaN) {
  var nodeName = element.nodeName.toLowerCase();
  var res = tabbableNode.test(nodeName) && !element.disabled || (nodeName === "a" ? element.href || isTabIndexNotNaN : isTabIndexNotNaN);
  return res && visible(element);
}

function tabbable(element) {
  var tabIndex = element.getAttribute("tabindex");
  if (tabIndex === null) tabIndex = undefined;
  var isTabIndexNaN = isNaN(tabIndex);
  return (isTabIndexNaN || tabIndex >= 0) && focusable(element, !isTabIndexNaN);
}

function findTabbableDescendants(element) {
  return [].slice.call(element.querySelectorAll("*"), 0).filter(tabbable);
}
module.exports = exports["default"];
});

unwrapExports(tabbable_1);

var focusManager = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleBlur = handleBlur;
exports.handleFocus = handleFocus;
exports.markForFocusLater = markForFocusLater;
exports.returnFocus = returnFocus;
exports.popWithoutFocus = popWithoutFocus;
exports.setupScopedFocus = setupScopedFocus;
exports.teardownScopedFocus = teardownScopedFocus;



var _tabbable2 = _interopRequireDefault(tabbable_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var focusLaterElements = [];
var modalElement = null;
var needToFocus = false;

function handleBlur() {
  needToFocus = true;
}

function handleFocus() {
  if (needToFocus) {
    needToFocus = false;
    if (!modalElement) {
      return;
    }
    // need to see how jQuery shims document.on('focusin') so we don't need the
    // setTimeout, firefox doesn't support focusin, if it did, we could focus
    // the element outside of a setTimeout. Side-effect of this implementation
    // is that the document.body gets focus, and then we focus our element right
    // after, seems fine.
    setTimeout(function () {
      if (modalElement.contains(document.activeElement)) {
        return;
      }
      var el = (0, _tabbable2.default)(modalElement)[0] || modalElement;
      el.focus();
    }, 0);
  }
}

function markForFocusLater() {
  focusLaterElements.push(document.activeElement);
}

/* eslint-disable no-console */
function returnFocus() {
  var toFocus = null;
  try {
    if (focusLaterElements.length !== 0) {
      toFocus = focusLaterElements.pop();
      toFocus.focus();
    }
    return;
  } catch (e) {
    console.warn(["You tried to return focus to", toFocus, "but it is not in the DOM anymore"].join(" "));
  }
}
/* eslint-enable no-console */

function popWithoutFocus() {
  focusLaterElements.length > 0 && focusLaterElements.pop();
}

function setupScopedFocus(element) {
  modalElement = element;

  if (window.addEventListener) {
    window.addEventListener("blur", handleBlur, false);
    document.addEventListener("focus", handleFocus, true);
  } else {
    window.attachEvent("onBlur", handleBlur);
    document.attachEvent("onFocus", handleFocus);
  }
}

function teardownScopedFocus() {
  modalElement = null;

  if (window.addEventListener) {
    window.removeEventListener("blur", handleBlur);
    document.removeEventListener("focus", handleFocus);
  } else {
    window.detachEvent("onBlur", handleBlur);
    document.detachEvent("onFocus", handleFocus);
  }
}
});

unwrapExports(focusManager);
var focusManager_1 = focusManager.handleBlur;
var focusManager_2 = focusManager.handleFocus;
var focusManager_3 = focusManager.markForFocusLater;
var focusManager_4 = focusManager.returnFocus;
var focusManager_5 = focusManager.popWithoutFocus;
var focusManager_6 = focusManager.setupScopedFocus;
var focusManager_7 = focusManager.teardownScopedFocus;

var scopeTab_1 = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = scopeTab;



var _tabbable2 = _interopRequireDefault(tabbable_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function scopeTab(node, event) {
  var tabbable = (0, _tabbable2.default)(node);

  if (!tabbable.length) {
    // Do nothing, since there are no elements that can receive focus.
    event.preventDefault();
    return;
  }

  var shiftKey = event.shiftKey;
  var head = tabbable[0];
  var tail = tabbable[tabbable.length - 1];

  // proceed with default browser behavior on tab.
  // Focus on last element on shift + tab.
  if (node === document.activeElement) {
    if (!shiftKey) return;
    target = tail;
  }

  var target;
  if (tail === document.activeElement && !shiftKey) {
    target = head;
  }

  if (head === document.activeElement && shiftKey) {
    target = tail;
  }

  if (target) {
    event.preventDefault();
    target.focus();
    return;
  }

  // Safari radio issue.
  //
  // Safari does not move the focus to the radio button,
  // so we need to force it to really walk through all elements.
  //
  // This is very error prone, since we are trying to guess
  // if it is a safari browser from the first occurence between
  // chrome or safari.
  //
  // The chrome user agent contains the first ocurrence
  // as the 'chrome/version' and later the 'safari/version'.
  var checkSafari = /(\bChrome\b|\bSafari\b)\//.exec(navigator.userAgent);
  var isSafariDesktop = checkSafari != null && checkSafari[1] != "Chrome" && /\biPod\b|\biPad\b/g.exec(navigator.userAgent) == null;

  // If we are not in safari desktop, let the browser control
  // the focus
  if (!isSafariDesktop) return;

  var x = tabbable.indexOf(document.activeElement);

  if (x > -1) {
    x += shiftKey ? -1 : 1;
  }

  event.preventDefault();

  tabbable[x].focus();
}
module.exports = exports["default"];
});

unwrapExports(scopeTab_1);

/**
 * Copyright 2014-2015, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

/**
 * Similar to invariant but only logs a warning if the condition is not met.
 * This can be used to log issues in development environments in critical
 * paths. Removing the logging code for production environments will keep the
 * same logic and follow the same code paths.
 */

var __DEV__ = process.env.NODE_ENV !== 'production';

var warning = function() {};

if (__DEV__) {
  warning = function(condition, format, args) {
    var len = arguments.length;
    args = new Array(len > 2 ? len - 2 : 0);
    for (var key = 2; key < len; key++) {
      args[key - 2] = arguments[key];
    }
    if (format === undefined) {
      throw new Error(
        '`warning(condition, format, ...args)` requires a warning ' +
        'message argument'
      );
    }

    if (format.length < 10 || (/^[s\W]*$/).test(format)) {
      throw new Error(
        'The warning format should be able to uniquely identify this ' +
        'warning. Please, use a more descriptive format than: ' + format
      );
    }

    if (!condition) {
      var argIndex = 0;
      var message = 'Warning: ' +
        format.replace(/%s/g, function() {
          return args[argIndex++];
        });
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch(x) {}
    }
  };
}

var warning_1 = warning;

var exenv = createCommonjsModule$1(function (module) {
/*!
  Copyright (c) 2015 Jed Watson.
  Based on code that is Copyright 2013-2015, Facebook, Inc.
  All rights reserved.
*/
/* global define */

(function () {

	var canUseDOM = !!(
		typeof window !== 'undefined' &&
		window.document &&
		window.document.createElement
	);

	var ExecutionEnvironment = {

		canUseDOM: canUseDOM,

		canUseWorkers: typeof Worker !== 'undefined',

		canUseEventListeners:
			canUseDOM && !!(window.addEventListener || window.attachEvent),

		canUseViewport: canUseDOM && !!window.screen

	};

	if (module.exports) {
		module.exports = ExecutionEnvironment;
	} else {
		window.ExecutionEnvironment = ExecutionEnvironment;
	}

}());
});

var safeHTMLElement = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.canUseDOM = undefined;



var _exenv2 = _interopRequireDefault(exenv);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EE = _exenv2.default;

var SafeHTMLElement = EE.canUseDOM ? window.HTMLElement : {};

var canUseDOM = exports.canUseDOM = EE.canUseDOM;

exports.default = SafeHTMLElement;
});

unwrapExports(safeHTMLElement);
var safeHTMLElement_1 = safeHTMLElement.canUseDOM;

var ariaAppHider = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertNodeList = assertNodeList;
exports.setElement = setElement;
exports.validateElement = validateElement;
exports.hide = hide;
exports.show = show;
exports.documentNotReadyOrSSRTesting = documentNotReadyOrSSRTesting;
exports.resetForTesting = resetForTesting;



var _warning2 = _interopRequireDefault(warning_1);



function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var globalElement = null;

function assertNodeList(nodeList, selector) {
  if (!nodeList || !nodeList.length) {
    throw new Error("react-modal: No elements were found for selector " + selector + ".");
  }
}

function setElement(element) {
  var useElement = element;
  if (typeof useElement === "string" && safeHTMLElement.canUseDOM) {
    var el = document.querySelectorAll(useElement);
    assertNodeList(el, useElement);
    useElement = "length" in el ? el[0] : el;
  }
  globalElement = useElement || globalElement;
  return globalElement;
}

function validateElement(appElement) {
  if (!appElement && !globalElement) {
    (0, _warning2.default)(false, ["react-modal: App element is not defined.", "Please use `Modal.setAppElement(el)` or set `appElement={el}`.", "This is needed so screen readers don't see main content", "when modal is opened. It is not recommended, but you can opt-out", "by setting `ariaHideApp={false}`."].join(" "));

    return false;
  }

  return true;
}

function hide(appElement) {
  if (validateElement(appElement)) {
    (appElement || globalElement).setAttribute("aria-hidden", "true");
  }
}

function show(appElement) {
  if (validateElement(appElement)) {
    (appElement || globalElement).removeAttribute("aria-hidden");
  }
}

function documentNotReadyOrSSRTesting() {
  globalElement = null;
}

function resetForTesting() {
  globalElement = null;
}
});

unwrapExports(ariaAppHider);
var ariaAppHider_1 = ariaAppHider.assertNodeList;
var ariaAppHider_2 = ariaAppHider.setElement;
var ariaAppHider_3 = ariaAppHider.validateElement;
var ariaAppHider_4 = ariaAppHider.hide;
var ariaAppHider_5 = ariaAppHider.show;
var ariaAppHider_6 = ariaAppHider.documentNotReadyOrSSRTesting;
var ariaAppHider_7 = ariaAppHider.resetForTesting;

var classList$1 = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dumpClassLists = dumpClassLists;
var htmlClassList = {};
var docBodyClassList = {};

function dumpClassLists() {
  if (process.env.NODE_ENV !== "production") {
    var classes = document.getElementsByTagName("html")[0].className;
    var buffer = "Show tracked classes:\n\n";

    buffer += "<html /> (" + classes + "):\n";
    for (var x in htmlClassList) {
      buffer += "  " + x + " " + htmlClassList[x] + "\n";
    }

    classes = document.body.className;

    // eslint-disable-next-line max-len
    buffer += "\n\ndoc.body (" + classes + "):\n";
    for (var _x in docBodyClassList) {
      buffer += "  " + _x + " " + docBodyClassList[_x] + "\n";
    }

    buffer += "\n";

    // eslint-disable-next-line no-console
    console.log(buffer);
  }
}

/**
 * Track the number of reference of a class.
 * @param {object} poll The poll to receive the reference.
 * @param {string} className The class name.
 * @return {string}
 */
var incrementReference = function incrementReference(poll, className) {
  if (!poll[className]) {
    poll[className] = 0;
  }
  poll[className] += 1;
  return className;
};

/**
 * Drop the reference of a class.
 * @param {object} poll The poll to receive the reference.
 * @param {string} className The class name.
 * @return {string}
 */
var decrementReference = function decrementReference(poll, className) {
  if (poll[className]) {
    poll[className] -= 1;
  }
  return className;
};

/**
 * Track a class and add to the given class list.
 * @param {Object} classListRef A class list of an element.
 * @param {Object} poll         The poll to be used.
 * @param {Array}  classes      The list of classes to be tracked.
 */
var trackClass = function trackClass(classListRef, poll, classes) {
  classes.forEach(function (className) {
    incrementReference(poll, className);
    classListRef.add(className);
  });
};

/**
 * Untrack a class and remove from the given class list if the reference
 * reaches 0.
 * @param {Object} classListRef A class list of an element.
 * @param {Object} poll         The poll to be used.
 * @param {Array}  classes      The list of classes to be untracked.
 */
var untrackClass = function untrackClass(classListRef, poll, classes) {
  classes.forEach(function (className) {
    decrementReference(poll, className);
    poll[className] === 0 && classListRef.remove(className);
  });
};

/**
 * Public inferface to add classes to the document.body.
 * @param {string} bodyClass The class string to be added.
 *                           It may contain more then one class
 *                           with ' ' as separator.
 */
var add = exports.add = function add(element, classString) {
  return trackClass(element.classList, element.nodeName.toLowerCase() == "html" ? htmlClassList : docBodyClassList, classString.split(" "));
};

/**
 * Public inferface to remove classes from the document.body.
 * @param {string} bodyClass The class string to be added.
 *                           It may contain more then one class
 *                           with ' ' as separator.
 */
var remove = exports.remove = function remove(element, classString) {
  return untrackClass(element.classList, element.nodeName.toLowerCase() == "html" ? htmlClassList : docBodyClassList, classString.split(" "));
};
});

unwrapExports(classList$1);
var classList_1 = classList$1.dumpClassLists;
var classList_2 = classList$1.add;
var classList_3 = classList$1.remove;

var ModalPortal_1 = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



var _react2 = _interopRequireDefault(React__default);



var _propTypes2 = _interopRequireDefault(PropTypes);



var focusManager$$1 = _interopRequireWildcard(focusManager);



var _scopeTab2 = _interopRequireDefault(scopeTab_1);



var ariaAppHider$$1 = _interopRequireWildcard(ariaAppHider);



var classList = _interopRequireWildcard(classList$1);



var _safeHTMLElement2 = _interopRequireDefault(safeHTMLElement);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// so that our CSS is statically analyzable
var CLASS_NAMES = {
  overlay: "ReactModal__Overlay",
  content: "ReactModal__Content"
};

var TAB_KEY = 9;
var ESC_KEY = 27;

var ariaHiddenInstances = 0;

var ModalPortal = function (_Component) {
  _inherits(ModalPortal, _Component);

  function ModalPortal(props) {
    _classCallCheck(this, ModalPortal);

    var _this = _possibleConstructorReturn(this, (ModalPortal.__proto__ || Object.getPrototypeOf(ModalPortal)).call(this, props));

    _this.setOverlayRef = function (overlay) {
      _this.overlay = overlay;
      _this.props.overlayRef && _this.props.overlayRef(overlay);
    };

    _this.setContentRef = function (content) {
      _this.content = content;
      _this.props.contentRef && _this.props.contentRef(content);
    };

    _this.afterClose = function () {
      var _this$props = _this.props,
          appElement = _this$props.appElement,
          ariaHideApp = _this$props.ariaHideApp,
          htmlOpenClassName = _this$props.htmlOpenClassName,
          bodyOpenClassName = _this$props.bodyOpenClassName;

      // Remove classes.

      classList.remove(document.body, bodyOpenClassName);

      htmlOpenClassName && classList.remove(document.getElementsByTagName("html")[0], htmlOpenClassName);

      // Reset aria-hidden attribute if all modals have been removed
      if (ariaHideApp && ariaHiddenInstances > 0) {
        ariaHiddenInstances -= 1;

        if (ariaHiddenInstances === 0) {
          ariaAppHider$$1.show(appElement);
        }
      }

      if (_this.props.shouldFocusAfterRender) {
        if (_this.props.shouldReturnFocusAfterClose) {
          focusManager$$1.returnFocus();
          focusManager$$1.teardownScopedFocus();
        } else {
          focusManager$$1.popWithoutFocus();
        }
      }
    };

    _this.open = function () {
      _this.beforeOpen();
      if (_this.state.afterOpen && _this.state.beforeClose) {
        clearTimeout(_this.closeTimer);
        _this.setState({ beforeClose: false });
      } else {
        if (_this.props.shouldFocusAfterRender) {
          focusManager$$1.setupScopedFocus(_this.node);
          focusManager$$1.markForFocusLater();
        }

        _this.setState({ isOpen: true }, function () {
          _this.setState({ afterOpen: true });

          if (_this.props.isOpen && _this.props.onAfterOpen) {
            _this.props.onAfterOpen();
          }
        });
      }
    };

    _this.close = function () {
      if (_this.props.closeTimeoutMS > 0) {
        _this.closeWithTimeout();
      } else {
        _this.closeWithoutTimeout();
      }
    };

    _this.focusContent = function () {
      return _this.content && !_this.contentHasFocus() && _this.content.focus();
    };

    _this.closeWithTimeout = function () {
      var closesAt = Date.now() + _this.props.closeTimeoutMS;
      _this.setState({ beforeClose: true, closesAt: closesAt }, function () {
        _this.closeTimer = setTimeout(_this.closeWithoutTimeout, _this.state.closesAt - Date.now());
      });
    };

    _this.closeWithoutTimeout = function () {
      _this.setState({
        beforeClose: false,
        isOpen: false,
        afterOpen: false,
        closesAt: null
      }, _this.afterClose);
    };

    _this.handleKeyDown = function (event) {
      if (event.keyCode === TAB_KEY) {
        (0, _scopeTab2.default)(_this.content, event);
      }

      if (_this.props.shouldCloseOnEsc && event.keyCode === ESC_KEY) {
        event.stopPropagation();
        _this.requestClose(event);
      }
    };

    _this.handleOverlayOnClick = function (event) {
      if (_this.shouldClose === null) {
        _this.shouldClose = true;
      }

      if (_this.shouldClose && _this.props.shouldCloseOnOverlayClick) {
        if (_this.ownerHandlesClose()) {
          _this.requestClose(event);
        } else {
          _this.focusContent();
        }
      }
      _this.shouldClose = null;
    };

    _this.handleContentOnMouseUp = function () {
      _this.shouldClose = false;
    };

    _this.handleOverlayOnMouseDown = function (event) {
      if (!_this.props.shouldCloseOnOverlayClick && event.target == _this.overlay) {
        event.preventDefault();
      }
    };

    _this.handleContentOnClick = function () {
      _this.shouldClose = false;
    };

    _this.handleContentOnMouseDown = function () {
      _this.shouldClose = false;
    };

    _this.requestClose = function (event) {
      return _this.ownerHandlesClose() && _this.props.onRequestClose(event);
    };

    _this.ownerHandlesClose = function () {
      return _this.props.onRequestClose;
    };

    _this.shouldBeClosed = function () {
      return !_this.state.isOpen && !_this.state.beforeClose;
    };

    _this.contentHasFocus = function () {
      return document.activeElement === _this.content || _this.content.contains(document.activeElement);
    };

    _this.buildClassName = function (which, additional) {
      var classNames = (typeof additional === "undefined" ? "undefined" : _typeof(additional)) === "object" ? additional : {
        base: CLASS_NAMES[which],
        afterOpen: CLASS_NAMES[which] + "--after-open",
        beforeClose: CLASS_NAMES[which] + "--before-close"
      };
      var className = classNames.base;
      if (_this.state.afterOpen) {
        className = className + " " + classNames.afterOpen;
      }
      if (_this.state.beforeClose) {
        className = className + " " + classNames.beforeClose;
      }
      return typeof additional === "string" && additional ? className + " " + additional : className;
    };

    _this.attributesFromObject = function (prefix, items) {
      return Object.keys(items).reduce(function (acc, name) {
        acc[prefix + "-" + name] = items[name];
        return acc;
      }, {});
    };

    _this.state = {
      afterOpen: false,
      beforeClose: false
    };

    _this.shouldClose = null;
    _this.moveFromContentToOverlay = null;
    return _this;
  }

  _createClass(ModalPortal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.isOpen) {
        this.open();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (process.env.NODE_ENV !== "production") {
        if (prevProps.bodyOpenClassName !== this.props.bodyOpenClassName) {
          // eslint-disable-next-line no-console
          console.warn('React-Modal: "bodyOpenClassName" prop has been modified. ' + "This may cause unexpected behavior when multiple modals are open.");
        }
        if (prevProps.htmlOpenClassName !== this.props.htmlOpenClassName) {
          // eslint-disable-next-line no-console
          console.warn('React-Modal: "htmlOpenClassName" prop has been modified. ' + "This may cause unexpected behavior when multiple modals are open.");
        }
      }

      if (this.props.isOpen && !prevProps.isOpen) {
        this.open();
      } else if (!this.props.isOpen && prevProps.isOpen) {
        this.close();
      }

      // Focus only needs to be set once when the modal is being opened
      if (this.props.shouldFocusAfterRender && this.state.isOpen && !prevState.isOpen) {
        this.focusContent();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.afterClose();
      clearTimeout(this.closeTimer);
    }
  }, {
    key: "beforeOpen",
    value: function beforeOpen() {
      var _props = this.props,
          appElement = _props.appElement,
          ariaHideApp = _props.ariaHideApp,
          htmlOpenClassName = _props.htmlOpenClassName,
          bodyOpenClassName = _props.bodyOpenClassName;

      // Add classes.

      classList.add(document.body, bodyOpenClassName);

      htmlOpenClassName && classList.add(document.getElementsByTagName("html")[0], htmlOpenClassName);

      if (ariaHideApp) {
        ariaHiddenInstances += 1;
        ariaAppHider$$1.hide(appElement);
      }
    }

    // Don't steal focus from inner elements

  }, {
    key: "render",
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          overlayClassName = _props2.overlayClassName,
          defaultStyles = _props2.defaultStyles;

      var contentStyles = className ? {} : defaultStyles.content;
      var overlayStyles = overlayClassName ? {} : defaultStyles.overlay;

      return this.shouldBeClosed() ? null : _react2.default.createElement(
        "div",
        {
          ref: this.setOverlayRef,
          className: this.buildClassName("overlay", overlayClassName),
          style: _extends({}, overlayStyles, this.props.style.overlay),
          onClick: this.handleOverlayOnClick,
          onMouseDown: this.handleOverlayOnMouseDown
        },
        _react2.default.createElement(
          "div",
          _extends({
            ref: this.setContentRef,
            style: _extends({}, contentStyles, this.props.style.content),
            className: this.buildClassName("content", className),
            tabIndex: "-1",
            onKeyDown: this.handleKeyDown,
            onMouseDown: this.handleContentOnMouseDown,
            onMouseUp: this.handleContentOnMouseUp,
            onClick: this.handleContentOnClick,
            role: this.props.role,
            "aria-label": this.props.contentLabel
          }, this.attributesFromObject("aria", this.props.aria || {}), this.attributesFromObject("data", this.props.data || {})),
          this.props.children
        )
      );
    }
  }]);

  return ModalPortal;
}(React__default.Component);

ModalPortal.defaultProps = {
  style: {
    overlay: {},
    content: {}
  },
  defaultStyles: {}
};
ModalPortal.propTypes = {
  isOpen: _propTypes2.default.bool.isRequired,
  defaultStyles: _propTypes2.default.shape({
    content: _propTypes2.default.object,
    overlay: _propTypes2.default.object
  }),
  style: _propTypes2.default.shape({
    content: _propTypes2.default.object,
    overlay: _propTypes2.default.object
  }),
  className: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
  overlayClassName: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
  bodyOpenClassName: _propTypes2.default.string,
  htmlOpenClassName: _propTypes2.default.string,
  ariaHideApp: _propTypes2.default.bool,
  appElement: _propTypes2.default.instanceOf(_safeHTMLElement2.default),
  onAfterOpen: _propTypes2.default.func,
  onRequestClose: _propTypes2.default.func,
  closeTimeoutMS: _propTypes2.default.number,
  shouldFocusAfterRender: _propTypes2.default.bool,
  shouldCloseOnOverlayClick: _propTypes2.default.bool,
  shouldReturnFocusAfterClose: _propTypes2.default.bool,
  role: _propTypes2.default.string,
  contentLabel: _propTypes2.default.string,
  aria: _propTypes2.default.object,
  data: _propTypes2.default.object,
  children: _propTypes2.default.node,
  shouldCloseOnEsc: _propTypes2.default.bool,
  overlayRef: _propTypes2.default.func,
  contentRef: _propTypes2.default.func,
  testId: _propTypes2.default.string
};
exports.default = ModalPortal;
module.exports = exports["default"];
});

unwrapExports(ModalPortal_1);

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

function componentWillMount() {
  // Call this.constructor.gDSFP to support sub-classes.
  var state = this.constructor.getDerivedStateFromProps(this.props, this.state);
  if (state !== null && state !== undefined) {
    this.setState(state);
  }
}

function componentWillReceiveProps(nextProps) {
  // Call this.constructor.gDSFP to support sub-classes.
  // Use the setState() updater to ensure state isn't stale in certain edge cases.
  function updater(prevState) {
    var state = this.constructor.getDerivedStateFromProps(nextProps, prevState);
    return state !== null && state !== undefined ? state : null;
  }
  // Binding "this" is important for shallow renderer support.
  this.setState(updater.bind(this));
}

function componentWillUpdate(nextProps, nextState) {
  try {
    var prevProps = this.props;
    var prevState = this.state;
    this.props = nextProps;
    this.state = nextState;
    this.__reactInternalSnapshotFlag = true;
    this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(
      prevProps,
      prevState
    );
  } finally {
    this.props = prevProps;
    this.state = prevState;
  }
}

// React may warn about cWM/cWRP/cWU methods being deprecated.
// Add a flag to suppress these warnings for this special case.
componentWillMount.__suppressDeprecationWarning = true;
componentWillReceiveProps.__suppressDeprecationWarning = true;
componentWillUpdate.__suppressDeprecationWarning = true;

function polyfill(Component) {
  var prototype = Component.prototype;

  if (!prototype || !prototype.isReactComponent) {
    throw new Error('Can only polyfill class components');
  }

  if (
    typeof Component.getDerivedStateFromProps !== 'function' &&
    typeof prototype.getSnapshotBeforeUpdate !== 'function'
  ) {
    return Component;
  }

  // If new component APIs are defined, "unsafe" lifecycles won't be called.
  // Error if any of these lifecycles are present,
  // Because they would work differently between older and newer (16.3+) versions of React.
  var foundWillMountName = null;
  var foundWillReceivePropsName = null;
  var foundWillUpdateName = null;
  if (typeof prototype.componentWillMount === 'function') {
    foundWillMountName = 'componentWillMount';
  } else if (typeof prototype.UNSAFE_componentWillMount === 'function') {
    foundWillMountName = 'UNSAFE_componentWillMount';
  }
  if (typeof prototype.componentWillReceiveProps === 'function') {
    foundWillReceivePropsName = 'componentWillReceiveProps';
  } else if (typeof prototype.UNSAFE_componentWillReceiveProps === 'function') {
    foundWillReceivePropsName = 'UNSAFE_componentWillReceiveProps';
  }
  if (typeof prototype.componentWillUpdate === 'function') {
    foundWillUpdateName = 'componentWillUpdate';
  } else if (typeof prototype.UNSAFE_componentWillUpdate === 'function') {
    foundWillUpdateName = 'UNSAFE_componentWillUpdate';
  }
  if (
    foundWillMountName !== null ||
    foundWillReceivePropsName !== null ||
    foundWillUpdateName !== null
  ) {
    var componentName = Component.displayName || Component.name;
    var newApiName =
      typeof Component.getDerivedStateFromProps === 'function'
        ? 'getDerivedStateFromProps()'
        : 'getSnapshotBeforeUpdate()';

    throw Error(
      'Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n' +
        componentName +
        ' uses ' +
        newApiName +
        ' but also contains the following legacy lifecycles:' +
        (foundWillMountName !== null ? '\n  ' + foundWillMountName : '') +
        (foundWillReceivePropsName !== null
          ? '\n  ' + foundWillReceivePropsName
          : '') +
        (foundWillUpdateName !== null ? '\n  ' + foundWillUpdateName : '') +
        '\n\nThe above lifecycles should be removed. Learn more about this warning here:\n' +
        'https://fb.me/react-async-component-lifecycle-hooks'
    );
  }

  // React <= 16.2 does not support static getDerivedStateFromProps.
  // As a workaround, use cWM and cWRP to invoke the new static lifecycle.
  // Newer versions of React will ignore these lifecycles if gDSFP exists.
  if (typeof Component.getDerivedStateFromProps === 'function') {
    prototype.componentWillMount = componentWillMount;
    prototype.componentWillReceiveProps = componentWillReceiveProps;
  }

  // React <= 16.2 does not support getSnapshotBeforeUpdate.
  // As a workaround, use cWU to invoke the new lifecycle.
  // Newer versions of React will ignore that lifecycle if gSBU exists.
  if (typeof prototype.getSnapshotBeforeUpdate === 'function') {
    if (typeof prototype.componentDidUpdate !== 'function') {
      throw new Error(
        'Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype'
      );
    }

    prototype.componentWillUpdate = componentWillUpdate;

    var componentDidUpdate = prototype.componentDidUpdate;

    prototype.componentDidUpdate = function componentDidUpdatePolyfill(
      prevProps,
      prevState,
      maybeSnapshot
    ) {
      // 16.3+ will not execute our will-update method;
      // It will pass a snapshot value to did-update though.
      // Older versions will require our polyfilled will-update value.
      // We need to handle both cases, but can't just check for the presence of "maybeSnapshot",
      // Because for <= 15.x versions this might be a "prevContext" object.
      // We also can't just check "__reactInternalSnapshot",
      // Because get-snapshot might return a falsy value.
      // So check for the explicit __reactInternalSnapshotFlag flag to determine behavior.
      var snapshot = this.__reactInternalSnapshotFlag
        ? this.__reactInternalSnapshot
        : maybeSnapshot;

      componentDidUpdate.call(this, prevProps, prevState, snapshot);
    };
  }

  return Component;
}

var reactLifecyclesCompat_es = /*#__PURE__*/Object.freeze({
    polyfill: polyfill
});

var Modal_1 = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bodyOpenClassName = exports.portalClassName = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



var _react2 = _interopRequireDefault(React__default);



var _reactDom2 = _interopRequireDefault(reactDom);



var _propTypes2 = _interopRequireDefault(PropTypes);



var _ModalPortal2 = _interopRequireDefault(ModalPortal_1);



var ariaAppHider$$1 = _interopRequireWildcard(ariaAppHider);



var _safeHTMLElement2 = _interopRequireDefault(safeHTMLElement);



function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var portalClassName = exports.portalClassName = "ReactModalPortal";
var bodyOpenClassName = exports.bodyOpenClassName = "ReactModal__Body--open";

var isReact16 = _reactDom2.default.createPortal !== undefined;
var createPortal = isReact16 ? _reactDom2.default.createPortal : _reactDom2.default.unstable_renderSubtreeIntoContainer;

function getParentElement(parentSelector) {
  return parentSelector();
}

var Modal = function (_Component) {
  _inherits(Modal, _Component);

  function Modal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Modal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Modal.__proto__ || Object.getPrototypeOf(Modal)).call.apply(_ref, [this].concat(args))), _this), _this.removePortal = function () {
      !isReact16 && _reactDom2.default.unmountComponentAtNode(_this.node);
      var parent = getParentElement(_this.props.parentSelector);
      parent.removeChild(_this.node);
    }, _this.portalRef = function (ref) {
      _this.portal = ref;
    }, _this.renderPortal = function (props) {
      var portal = createPortal(_this, _react2.default.createElement(_ModalPortal2.default, _extends({ defaultStyles: Modal.defaultStyles }, props)), _this.node);
      _this.portalRef(portal);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Modal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!safeHTMLElement.canUseDOM) return;

      if (!isReact16) {
        this.node = document.createElement("div");
      }
      this.node.className = this.props.portalClassName;

      var parent = getParentElement(this.props.parentSelector);
      parent.appendChild(this.node);

      !isReact16 && this.renderPortal(this.props);
    }
  }, {
    key: "getSnapshotBeforeUpdate",
    value: function getSnapshotBeforeUpdate(prevProps) {
      var prevParent = getParentElement(prevProps.parentSelector);
      var nextParent = getParentElement(this.props.parentSelector);
      return { prevParent: prevParent, nextParent: nextParent };
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, _, snapshot) {
      if (!safeHTMLElement.canUseDOM) return;
      var _props = this.props,
          isOpen = _props.isOpen,
          portalClassName = _props.portalClassName;


      if (prevProps.portalClassName !== portalClassName) {
        this.node.className = portalClassName;
      }

      var prevParent = snapshot.prevParent,
          nextParent = snapshot.nextParent;

      if (nextParent !== prevParent) {
        prevParent.removeChild(this.node);
        nextParent.appendChild(this.node);
      }

      // Stop unnecessary renders if modal is remaining closed
      if (!prevProps.isOpen && !isOpen) return;

      !isReact16 && this.renderPortal(this.props);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (!safeHTMLElement.canUseDOM || !this.node || !this.portal) return;

      var state = this.portal.state;
      var now = Date.now();
      var closesAt = state.isOpen && this.props.closeTimeoutMS && (state.closesAt || now + this.props.closeTimeoutMS);

      if (closesAt) {
        if (!state.beforeClose) {
          this.portal.closeWithTimeout();
        }

        setTimeout(this.removePortal, closesAt - now);
      } else {
        this.removePortal();
      }
    }
  }, {
    key: "render",
    value: function render() {
      if (!safeHTMLElement.canUseDOM || !isReact16) {
        return null;
      }

      if (!this.node && isReact16) {
        this.node = document.createElement("div");
      }

      return createPortal(_react2.default.createElement(_ModalPortal2.default, _extends({
        ref: this.portalRef,
        defaultStyles: Modal.defaultStyles
      }, this.props)), this.node);
    }
  }], [{
    key: "setAppElement",
    value: function setAppElement(element) {
      ariaAppHider$$1.setElement(element);
    }

    /* eslint-disable react/no-unused-prop-types */

    /* eslint-enable react/no-unused-prop-types */

  }]);

  return Modal;
}(React__default.Component);

Modal.propTypes = {
  isOpen: _propTypes2.default.bool.isRequired,
  style: _propTypes2.default.shape({
    content: _propTypes2.default.object,
    overlay: _propTypes2.default.object
  }),
  portalClassName: _propTypes2.default.string,
  bodyOpenClassName: _propTypes2.default.string,
  htmlOpenClassName: _propTypes2.default.string,
  className: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.shape({
    base: _propTypes2.default.string.isRequired,
    afterOpen: _propTypes2.default.string.isRequired,
    beforeClose: _propTypes2.default.string.isRequired
  })]),
  overlayClassName: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.shape({
    base: _propTypes2.default.string.isRequired,
    afterOpen: _propTypes2.default.string.isRequired,
    beforeClose: _propTypes2.default.string.isRequired
  })]),
  appElement: _propTypes2.default.instanceOf(_safeHTMLElement2.default),
  onAfterOpen: _propTypes2.default.func,
  onRequestClose: _propTypes2.default.func,
  closeTimeoutMS: _propTypes2.default.number,
  ariaHideApp: _propTypes2.default.bool,
  shouldFocusAfterRender: _propTypes2.default.bool,
  shouldCloseOnOverlayClick: _propTypes2.default.bool,
  shouldReturnFocusAfterClose: _propTypes2.default.bool,
  parentSelector: _propTypes2.default.func,
  aria: _propTypes2.default.object,
  data: _propTypes2.default.object,
  role: _propTypes2.default.string,
  contentLabel: _propTypes2.default.string,
  shouldCloseOnEsc: _propTypes2.default.bool,
  overlayRef: _propTypes2.default.func,
  contentRef: _propTypes2.default.func
};
Modal.defaultProps = {
  isOpen: false,
  portalClassName: portalClassName,
  bodyOpenClassName: bodyOpenClassName,
  role: "dialog",
  ariaHideApp: true,
  closeTimeoutMS: 0,
  shouldFocusAfterRender: true,
  shouldCloseOnEsc: true,
  shouldCloseOnOverlayClick: true,
  shouldReturnFocusAfterClose: true,
  parentSelector: function parentSelector() {
    return document.body;
  }
};
Modal.defaultStyles = {
  overlay: {
    position: "fixed",
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    backgroundColor: "rgba(255, 255, 255, 0.75)"
  },
  content: {
    position: "absolute",
    top: "40px",
    left: "40px",
    right: "40px",
    bottom: "40px",
    border: "1px solid #ccc",
    background: "#fff",
    overflow: "auto",
    WebkitOverflowScrolling: "touch",
    borderRadius: "4px",
    outline: "none",
    padding: "20px"
  }
};


(0, reactLifecyclesCompat_es.polyfill)(Modal);

exports.default = Modal;
});

unwrapExports(Modal_1);
var Modal_2 = Modal_1.bodyOpenClassName;
var Modal_3 = Modal_1.portalClassName;

var lib = createCommonjsModule$1(function (module, exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});



var _Modal2 = _interopRequireDefault(Modal_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _Modal2.default;
module.exports = exports["default"];
});

var Modal$1 = unwrapExports(lib);

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css$1 = ".Modal {\n  /* position: absolute;\n  left: 40px;\n  right: 40px; */\n  position: relative;\n  width: 80%;\n  background-color: #fff;\n  border-radius: 4px;\n  max-width: 450px;\n  margin: auto;\n  padding: 20px;\n  height: auto;\n}\n\n.ModalNoMargins {\n  /* position: absolute;\n  left: 40px;\n  right: 40px; */\n  position: relative;\n  width: 80%;\n  background-color: #fff;\n  border-radius: 4px;\n  max-width: 450px;\n  margin: auto;\n  height: auto;\n}\n\n.ModalNoMarginsHeader {\n  /* position: absolute;\n  left: 40px;\n  right: 40px; */\n  position: relative;\n  width: 80%;\n  background-color: #fff;\n  border-radius: 6px;\n  max-width: 450px;\n  margin: auto;\n  height: auto;\n}\n\n.Modal:focus {\n  outline: none;\n}\n\n.ModalNoMargins:focus {\n  outline: none;\n}\n\n@media screen and (max-width: 600px) {\n  .Modal {\n    left: 10px;\n    right: 10px;\n  }\n\n  .ModalNoMargins {\n    left: 10px;\n    right: 10px;\n  }\n}\n\n.ReactModal__Content {\n  opacity: 0;\n}\n\n.ReactModal__Body--open {\n  overflow: hidden;\n  position: fixed;\n  width: 100%;\n  height: 100%;\n}\n\n.ReactModal__Content--after-open {\n  opacity: 1;\n  transition: opacity 300ms;\n}\n\n.ReactModal__Content--before-close {\n  opacity: 0;\n}\n\n.Overlay {\n  position: fixed;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background-color: rgba(0, 0, 0, 0.8);\n  display: flex;\n  align-items: center;\n  z-index: 100;\n  overflow: scroll;\n}\n";
styleInject(css$1);

var HeaderStyles = styled__default.div(templateObject_1$9 || (templateObject_1$9 = __makeTemplateObject(["\n  background-color: ", ";\n  height: 55px;\n  border-radius: 4px 4px 0px 0px;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n\n  * {\n    font-family: ", ";\n    font-weight: 600;\n    color: #fff;\n    margin: 0px;\n    font-size: 16px;\n    margin-left: 20px;\n  }\n"], ["\n  background-color: ", ";\n  height: 55px;\n  border-radius: 4px 4px 0px 0px;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n\n  * {\n    font-family: ", ";\n    font-weight: 600;\n    color: #fff;\n    margin: 0px;\n    font-size: 16px;\n    margin-left: 20px;\n  }\n"])), function (props) { return props.color ? props.color : '#18434D'; }, regularFont);
var IconContainer$1 = styled__default.div(templateObject_2$3 || (templateObject_2$3 = __makeTemplateObject(["\n  position: absolute;\n  right: 20px;\n  top: 20px;\n"], ["\n  position: absolute;\n  right: 20px;\n  top: 20px;\n"])));
var MainContainer = styled__default.div(templateObject_3$3 || (templateObject_3$3 = __makeTemplateObject(["\n  padding: ", ";\n"], ["\n  padding: ",
    ";\n"])), function (props) {
    return props.options.header ? '0px 20px 20px 20px' : '20px';
});
var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Dialog.prototype.render = function () {
        var _a = this.props, children = _a.children, open = _a.open, onClose = _a.onClose, header = _a.header, style = _a.style;
        return (React.createElement(Modal$1, { isOpen: open, onRequestClose: function () { return onClose(); }, className: header ? 'ModalNoMarginsHeader' : 'ModalNoMargins', style: style, overlayClassName: "Overlay", ariaHideApp: false },
            header ? React.createElement(HeaderStyles, { color: style && style.header && style.header.color ? style.header.color : '' }, header) : null,
            React.createElement(MainContainer, { options: { header: header } },
                React.createElement(IconContainer$1, { onClick: function () { return onClose(); } },
                    React.createElement(FontAwesomeIcon, { icon: faTimes, style: {
                            opacity: 0.5,
                            cursor: 'pointer',
                            color: header ? '#fff' : '#000',
                        } })),
                children)));
    };
    return Dialog;
}(React.Component));
var templateObject_1$9, templateObject_2$3, templateObject_3$3;

var css$2 = "@charset 'UTF-8';\n/* Slider */\n.slick-loading .slick-list {\n}\n\n/* Arrows */\n.slick-prev,\n.slick-next {\n  font-size: 0;\n  line-height: 0;\n\n  position: absolute;\n  top: 50%;\n\n  display: block;\n\n  width: 40px;\n  height: 40px;\n  border-radius: 50px;\n  padding: 0;\n  -webkit-transform: translate(0, -50%);\n  -ms-transform: translate(0, -50%);\n  transform: translate(0, -50%);\n\n  cursor: pointer;\n\n  border: none;\n  outline: none;\n}\n.slick-prev:hover,\n.slick-prev:focus,\n.slick-next:hover,\n.slick-next:focus {\n  outline: none;\n  font-size: 30px;\n  display: flex !important;\n  justify-content: center;\n  align-items: center;\n  background-color: #fff;\n  color: #125566;\n}\n.slick-prev:hover:before,\n.slick-prev:focus:before,\n.slick-next:hover:before,\n.slick-next:focus:before {\n  opacity: 1;\n  font-size: 30px;\n  display: flex !important;\n  justify-content: center;\n  align-items: center;\n  background-color: #fff;\n  color: #125566;\n}\n.slick-prev.slick-disabled:before,\n.slick-next.slick-disabled:before {\n  opacity: 0.25;\n}\n\n.slick-prev:before,\n.slick-next:before {\n  font-family: 'slick';\n  font-size: 20px;\n  line-height: 1;\n\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.slick-secondary {\n  top: 40%;\n  background-color: #125566 !important;\n  color: #fff !important;\n}\n\n.slick-secondary:hover,\n.slick-secondary:focus {\n  background-color: #125566;\n  color: #fff;\n}\n\n.slick-prev {\n  left: -45px;\n  font-size: 30px;\n  display: flex !important;\n  justify-content: center;\n  align-items: center;\n  background-color: #fff;\n  color: #125566;\n}\n.slick-prev svg {\n  margin-right: 3px;\n}\n[dir='rtl'] .slick-prev {\n  right: -45px;\n  left: auto;\n}\n.slick-prev:before {\n}\n[dir='rtl'] .slick-prev:before {\n}\n\n.slick-next {\n  right: -45px;\n  font-size: 30px;\n  display: flex !important;\n  justify-content: center;\n  align-items: center;\n  background-color: #fff;\n  color: #125566;\n}\n.slick-next svg {\n  margin-left: 3px;\n}\n[dir='rtl'] .slick-next {\n  right: auto;\n  left: -45px;\n}\n.slick-next:before {\n}\n[dir='rtl'] .slick-next:before {\n}\n\n/* Dots */\n.slick-dotted.slick-slider {\n  margin-bottom: 30px;\n}\n\n.slick-dots {\n  position: absolute;\n  bottom: -25px;\n\n  display: block;\n\n  width: 100%;\n  padding: 0;\n  margin: 0;\n\n  list-style: none;\n\n  text-align: center;\n}\n.slick-dots li {\n  position: relative;\n\n  display: inline-block;\n  padding: 0;\n\n  cursor: pointer;\n}\n.slick-dots li button {\n  font-size: 0;\n  line-height: 0;\n  background-color: #f4f4f4;\n\n  margin-right: 10px;\n\n  display: block;\n  padding: 5px;\n  border: 0;\n  border-radius: 50px;\n\n  cursor: pointer;\n\n  outline: none;\n}\n.slick-dots li button:hover {\n  outline: none;\n  background-color: #1b6672;\n}\n.slick-dots li button:focus,\n.slick-dots li button:active {\n}\n.slick-dots li button:hover:before,\n.slick-dots li button:focus:before {\n  opacity: 1;\n}\n.slick-dots li button:before {\n  font-family: 'slick';\n  font-size: 6px;\n  line-height: 20px;\n\n  position: absolute;\n  top: 0;\n  left: 0;\n\n  text-align: center;\n\n  opacity: 0.25;\n\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n.slick-dots li.slick-active button {\n  background: linear-gradient(\n    45deg,\n    rgba(0, 234, 255, 1) 0%,\n    rgba(60, 140, 231, 1) 100%\n  );\n}\n";
styleInject(css$2);

var css$3 = "* {\n  outline: none;\n}\n\n/* Slider */\n.slick-slider {\n  position: relative;\n  width: 100%;\n  margin: 0 auto;\n\n  display: block;\n  box-sizing: border-box;\n\n  -webkit-user-select: none;\n  -moz-user-select: none;\n  -ms-user-select: none;\n  user-select: none;\n\n  -webkit-touch-callout: none;\n  -khtml-user-select: none;\n  -ms-touch-action: pan-y;\n  touch-action: pan-y;\n  -webkit-tap-highlight-color: transparent;\n}\n\n.slick-list {\n  position: relative;\n\n  display: block;\n  overflow: hidden;\n\n  margin: 0;\n  padding: 0;\n}\n.slick-list:focus {\n  outline: none;\n}\n.slick-list.dragging {\n  cursor: pointer;\n  cursor: hand;\n}\n\n.slick-slider .slick-track,\n.slick-slider .slick-list {\n  -webkit-transform: translate3d(0, 0, 0);\n  -moz-transform: translate3d(0, 0, 0);\n  -ms-transform: translate3d(0, 0, 0);\n  -o-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n\n.less-distribution {\n  width: 100% !important;\n  display: flex !important;\n  justify-content: space-between !important;\n}\n\n.slick-track {\n  position: relative;\n  top: 0;\n  left: 0;\n\n  display: block;\n  margin-left: auto;\n  margin-right: auto;\n}\n.slick-track:before,\n.slick-track:after {\n  display: table;\n\n  content: '';\n}\n.slick-track:after {\n  clear: both;\n}\n.slick-loading .slick-track {\n  visibility: hidden;\n}\n\n.slick-slide {\n  display: none;\n  float: left;\n\n  height: 100%;\n  min-height: 1px;\n}\n[dir='rtl'] .slick-slide {\n  float: right;\n}\n.slick-slide img {\n  display: block;\n}\n.slick-slide.slick-loading img {\n  display: none;\n}\n.slick-slide.dragging img {\n  pointer-events: none;\n}\n.slick-initialized .slick-slide {\n  display: block;\n}\n.slick-loading .slick-slide {\n  visibility: hidden;\n}\n.slick-vertical .slick-slide {\n  display: block;\n\n  height: auto;\n\n  border: 1px solid transparent;\n}\n.slick-arrow.slick-hidden {\n  display: none;\n}\n";
styleInject(css$3);

var StyledSlider = styled__default(ReactSlider)(templateObject_1$a || (templateObject_1$a = __makeTemplateObject(["\n  .slick-track {\n    width: ", ";\n    display: ", ";\n    justify-content: ", ";\n  }\n\n  .slick-list {\n    max-height: ", ";\n  }\n"], ["\n  .slick-track {\n    width: ", ";\n    display: ", ";\n    justify-content: ",
    ";\n  }\n\n  .slick-list {\n    max-height: ",
    ";\n  }\n"])), function (props) { return (props.options.less ? null : '100% !important'); }, function (props) { return (props.options.less ? null : 'flex !important'); }, function (props) {
    return props.options.less ? null : 'space-between !important';
}, function (props) {
    return props.options.maxHeightSlick ? props.options.maxHeightSlick : null;
});
var Arrow = function (_a) {
    var className = _a.className, style = _a.style, onClick = _a.onClick, icon = _a.icon, disabled = _a.disabled, invertedArrows = _a.invertedArrows;
    if (disabled) {
        return null;
    }
    return (React.createElement("div", { className: invertedArrows ? className + " slick-secondary" : className, style: __assign({}, style), onClick: onClick },
        React.createElement(FontAwesomeIcon, { icon: icon })));
};
var Slider = function (_a) {
    var children = _a.children, itemsToShow = _a.itemsToShow, disableDots = _a.disableDots, invertedArrows = _a.invertedArrows, disableArrows = _a.disableArrows, initialSlide = _a.initialSlide, _b = _a.maxHeightSlick, maxHeightSlick = _b === void 0 ? '' : _b, beforeChange = _a.beforeChange, afterChange = _a.afterChange;
    var settings = {
        dots: disableDots ? false : true,
        slidesToShow: itemsToShow,
        slidesToScroll: itemsToShow,
        infinite: React.Children.count(children) >= itemsToShow,
        initialSlide: initialSlide,
        centerMode: true,
        beforeChange: beforeChange,
        afterChange: afterChange,
        nextArrow: (React.createElement(Arrow, { invertedArrows: invertedArrows, icon: faAngleRight, disabled: disableArrows })),
        prevArrow: (React.createElement(Arrow, { invertedArrows: invertedArrows, icon: faAngleLeft, disabled: disableArrows })),
    };
    return (React.createElement(StyledSlider, __assign({}, settings, { options: {
            less: React.Children.count(children) >= itemsToShow,
            maxHeightSlick: maxHeightSlick,
        } }), children));
};
Slider.defaultProps = {
    disableDots: false,
    disableArrows: false,
    invertedArrows: false,
};
var templateObject_1$a;

var OutsideClick = /** @class */ (function (_super) {
    __extends(OutsideClick, _super);
    function OutsideClick() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.wrapperRef = React.createRef();
        _this.handleClickOutside = function (event) {
            if (_this.wrapperRef &&
                _this.wrapperRef.current &&
                !_this.wrapperRef.current.contains(event.target)) {
                _this.props.outSideAction();
            }
        };
        return _this;
    }
    OutsideClick.prototype.componentDidMount = function () {
        document.addEventListener('mousedown', this.handleClickOutside);
    };
    OutsideClick.prototype.componentWillUnmount = function () {
        document.removeEventListener('mousedown', this.handleClickOutside);
    };
    OutsideClick.prototype.render = function () {
        var children = this.props.children;
        return (React.createElement("div", { ref: this.wrapperRef, style: this.props.style, className: this.props.className }, children));
    };
    return OutsideClick;
}(React.Component));

var SelectContainer = styled__default.div(templateObject_1$b || (templateObject_1$b = __makeTemplateObject(["\n  position: relative;\n  font-family: ", ";\n  color: #fff;\n"], ["\n  position: relative;\n  font-family: ", ";\n  color: #fff;\n"])), regularFont);
var SelectInput = styled__default.div(templateObject_2$4 || (templateObject_2$4 = __makeTemplateObject(["\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n\n  cursor: pointer;\n  border: 1px solid #fff;\n  border-radius: 3px;\n  padding: 10px;\n"], ["\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n\n  cursor: pointer;\n  border: 1px solid #fff;\n  border-radius: 3px;\n  padding: 10px;\n"])));
var SelectOptions = styled__default.div(templateObject_3$4 || (templateObject_3$4 = __makeTemplateObject(["\n  position: absolute;\n  bottom: ", ";\n  padding: 10px;\n  color: #fff;\n  background-color: #4d4dce;\n  border-radius: 3px;\n  margin-top: 5px;\n  width: 100%;\n  box-sizing: border-box;\n"], ["\n  position: absolute;\n  bottom: ",
    ";\n  padding: 10px;\n  color: #fff;\n  background-color: #4d4dce;\n  border-radius: 3px;\n  margin-top: 5px;\n  width: 100%;\n  box-sizing: border-box;\n"])), function (props) {
    return props.options.anchor === 'bottom'
        ? props.options.inputHeight + 5 + "px"
        : null;
});
var SimpleOption = styled__default.div(templateObject_4$2 || (templateObject_4$2 = __makeTemplateObject(["\n  cursor: pointer;\n"], ["\n  cursor: pointer;\n"])));
var Select = /** @class */ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            showOptions: false,
            inputHeight: 0,
            activeElement: {
                text: 'Selecciona una opción',
                value: null,
            },
        };
        _this.renderOptions = function () {
            return _this.props.options.map(function (option) {
                return (React.createElement(SimpleOption, { key: option.text, className: "select-option", onClick: function () {
                        _this.setState({ activeElement: option, showOptions: false });
                        _this.props.onChange(option);
                    } }, option.text));
            });
        };
        return _this;
    }
    Select.prototype.componentDidMount = function () {
        var _this = this;
        var element = document.querySelector('.outsideClick');
        this.setState({ inputHeight: element.offsetHeight });
        this.props.options.map(function (option) {
            if (option.selected) {
                _this.setState({
                    activeElement: option,
                });
            }
            return;
        });
    };
    Select.prototype.render = function () {
        var _this = this;
        var anchor = this.props.anchor;
        var inputHeight = this.state.inputHeight;
        return (React.createElement(React.Fragment, null,
            React.createElement(OutsideClick, { outSideAction: function () { return _this.setState({ showOptions: false }); }, style: {
                    width: this.props.width + "px",
                }, className: "outsideClick" },
                React.createElement(SelectContainer, { className: this.props.className + " select-container" },
                    React.createElement(SelectInput, { className: "select-input", onClick: function () {
                            return _this.setState(function (prevState) { return ({
                                showOptions: !prevState.showOptions,
                            }); });
                        }, style: {
                            height: this.props.height + "px",
                        } },
                        this.state.activeElement.text,
                        React.createElement(FontAwesomeIcon, { icon: faAngleDown })),
                    this.state.showOptions ? (React.createElement(SelectOptions, { className: "select-options-container", options: { anchor: anchor, inputHeight: inputHeight } }, this.renderOptions())) : null))));
    };
    return Select;
}(React.Component));
var templateObject_1$b, templateObject_2$4, templateObject_3$4, templateObject_4$2;

var Icon = styled__default(FontAwesomeIcon)(templateObject_1$c || (templateObject_1$c = __makeTemplateObject(["\n  width: 13px !important;\n  height: 20px !important;\n  color: white !important;\n  background-color: transparent !important;\n\n  @media (min-width: 768px) {\n    color: ", " !important;\n  }\n"], ["\n  width: 13px !important;\n  height: 20px !important;\n  color: white !important;\n  background-color: transparent !important;\n\n  @media (min-width: 768px) {\n    color: ", " !important;\n  }\n"])), colors.gray.slideArrow);
var SlideButton = styled__default.button(templateObject_2$5 || (templateObject_2$5 = __makeTemplateObject(["\n  background: none;\n  border: none;\n"], ["\n  background: none;\n  border: none;\n"])));
var StyledReactSlider = styled__default(ReactSlider)(templateObject_3$5 || (templateObject_3$5 = __makeTemplateObject(["\n  .slick-prev {\n    left: -15px;\n    ", ";\n  }\n\n  .slick-next {\n    right: -15px;\n    ", ";\n  }\n"], ["\n  .slick-prev {\n    left: -15px;\n    ", ";\n  }\n\n  .slick-next {\n    right: -15px;\n    ", ";\n  }\n"])), function (props) { return !props.options.showLeftArrow && 'opacity: 0'; }, function (props) { return !props.options.showRightArrow && 'opacity: 0'; });
var _a = React.createContext({
    isDragging: false,
}), Provider = _a.Provider, Consumer = _a.Consumer;
var Slide = /** @class */ (function (_super) {
    __extends(Slide, _super);
    function Slide() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClick = function () {
            var _a = _this.props, onClick = _a.onClick, keyValue = _a.keyValue, isDragging = _a.isDragging;
            if (onClick && !isDragging) {
                onClick(keyValue);
            }
        };
        return _this;
    }
    Slide.prototype.render = function () {
        var children = this.props.children;
        return React.createElement(SlideButton, { onClick: this.onClick }, children);
    };
    return Slide;
}(React.Component));
var DaySlider = /** @class */ (function (_super) {
    __extends(DaySlider, _super);
    function DaySlider() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isDragging: false,
        };
        _this.startDragging = function () { return _this.setState({ isDragging: true }); };
        _this.stopDragging = function (currentSlide) {
            var afterSlideChange = _this.props.afterSlideChange;
            _this.setState({ isDragging: false });
            if (afterSlideChange) {
                afterSlideChange(currentSlide);
            }
        };
        return _this;
    }
    DaySlider.prototype.render = function () {
        var _a = this.props, children = _a.children, showLeftArrow = _a.showLeftArrow, showRightArrow = _a.showRightArrow, rest = __rest(_a, ["children", "showLeftArrow", "showRightArrow"]);
        return (React.createElement(Provider, { value: this.state },
            React.createElement(StyledReactSlider, __assign({ options: { showLeftArrow: showLeftArrow, showRightArrow: showRightArrow }, slidesToScroll: 7, slidesToShow: 14, responsive: [
                    {
                        breakpoint: 1024,
                        settings: {
                            slidesToShow: 7,
                        },
                    },
                ], prevArrow: React.createElement(Icon, { icon: faAngleLeft }), nextArrow: React.createElement(Icon, { icon: faAngleRight }), beforeChange: this.startDragging, afterChange: this.stopDragging }, rest), children)));
    };
    DaySlider.defaultProps = {
        variableWidth: false,
        swipeToSlide: true,
        afterSlideChange: function () { },
        showLeftArrow: true,
        showRightArrow: true,
    };
    DaySlider.Slide = function (props) { return (React.createElement(Consumer, null, function (context) { return React.createElement(Slide, __assign({}, props, { isDragging: context.isDragging })); })); };
    return DaySlider;
}(React.Component));
var templateObject_1$c, templateObject_2$5, templateObject_3$5;

var setFontSize = function (size) {
    switch (size) {
        case 'l':
            return '38px';
        case 's':
            return '30px';
        default:
            return '34px';
    }
};
function getMargin(props) {
    if (props.options) {
        if (props.options.margin) {
            var margin = props.options.margin;
            switch (margin) {
                case 'noMargin':
                    return 'margin-top: 0; margin-bottom: 0;';
                case 'noTopMargin':
                    return 'margin-top: 0;';
                case 'noBottomMargin':
                    return 'margin-bottom: 0;';
                default:
                    return '';
            }
        }
        if (props.options.halfMargin) {
            var margin = props.options.halfMargin;
            switch (margin) {
                case 'halfMargin':
                    return 'margin-top: 0.42em; margin-bottom: 0.42em;';
                case 'halfTopMargin':
                    return 'margin-top: 0.42em;';
                case 'halfBottomMargin':
                    return 'margin-bottom: 0.42em;';
                default:
                    return '';
            }
        }
    }
    return '';
}
var ExtendedH1 = styled__default.h1(templateObject_1$d || (templateObject_1$d = __makeTemplateObject(["\n  font-family: ", ";\n  font-size: ", ";\n  font-weight: 700;\n  color: ", ";\n  ", ";\n  text-align: ", ";\n"], ["\n  font-family: ", ";\n  font-size: ", ";\n  font-weight: 700;\n  color: ", ";\n  ", ";\n  text-align: ",
    ";\n"])), mainFont, function (props) { return setFontSize(props.options.size); }, function (props) { return props.options.color; }, function (props) { return getMargin(props); }, function (props) {
    return props.options.textAlign ? props.options.textAlign : 'left';
});
var H1 = function (props) {
    var children = props.children, color = props.color, size = props.size, _a = props.margin, margin = _a === void 0 ? '' : _a, _b = props.halfMargin, halfMargin = _b === void 0 ? '' : _b, style = props.style, rest = __rest(props, ["children", "color", "size", "margin", "halfMargin", "style"]);
    return (React.createElement(ExtendedH1, __assign({ options: { color: color, size: size, margin: margin, halfMargin: halfMargin }, style: style }, rest), children));
};
var templateObject_1$d;

var setFontSize$1 = function (size) {
    switch (size) {
        case 'l':
            return '28px';
        case 's':
            return '20px';
        default:
            return '24px';
    }
};
var ExtendedH2 = styled__default.h2(templateObject_1$e || (templateObject_1$e = __makeTemplateObject(["\n  font-family: ", ";\n  font-size: ", ";\n  font-weight: 600;\n  color: ", ";\n  text-align: ", ";\n"], ["\n  font-family: ", ";\n  font-size: ", ";\n  font-weight: 600;\n  color: ", ";\n  text-align: ",
    ";\n"])), mainFont, function (props) { return setFontSize$1(props.options.size); }, function (props) { return props.options.color; }, function (props) {
    return props.options.textAlign ? props.options.textAlign : 'left';
});
var H2 = function (props) {
    var children = props.children, color = props.color, size = props.size, style = props.style, textAlign = props.textAlign, rest = __rest(props, ["children", "color", "size", "style", "textAlign"]);
    return (React.createElement(ExtendedH2, __assign({ options: { color: color, size: size, textAlign: textAlign }, style: style }, rest), children));
};
var templateObject_1$e;

var setFontSize$2 = function (size) {
    switch (size) {
        case 'l':
            return '26px';
        case 's':
            return '18px';
        default:
            return '22px';
    }
};
var ExtendedH3 = styled__default.h3(templateObject_1$f || (templateObject_1$f = __makeTemplateObject(["\n  font-family: ", ";\n  font-size: ", ";\n  font-weight: 600;\n  color: ", ";\n  text-align: ", ";\n"], ["\n  font-family: ", ";\n  font-size: ", ";\n  font-weight: 600;\n  color: ", ";\n  text-align: ",
    ";\n"])), mainFont, function (props) { return setFontSize$2(props.options.size); }, function (props) { return props.options.color; }, function (props) {
    return props.options.textAlign ? props.options.textAlign : 'left';
});
var H3 = function (props) {
    var children = props.children, color = props.color, size = props.size, style = props.style, textAlign = props.textAlign, rest = __rest(props, ["children", "color", "size", "style", "textAlign"]);
    return (React.createElement(ExtendedH3, __assign({ options: { color: color, size: size, textAlign: textAlign }, style: style }, rest), children));
};
var templateObject_1$f;

var setFontSize$3 = function (size) {
    switch (size) {
        case 'l':
            return '18px';
        case 's':
            return '12px';
        default:
            return '16px';
    }
};
function getMargin$1(props) {
    if (props.options) {
        if (props.options.margin) {
            var margin = props.options.margin;
            switch (margin) {
                case 'noMargin':
                    return 'margin-top: 0; margin-bottom: 0;';
                case 'noTopMargin':
                    return 'margin-top: 0;';
                case 'noBottomMargin':
                    return 'margin-bottom: 0;';
                default:
                    return '';
            }
        }
        if (props.options.halfMargin) {
            var margin = props.options.halfMargin;
            switch (margin) {
                case 'halfMargin':
                    return 'margin-top: 0.5em; margin-bottom: 0.5em;';
                case 'halfTopMargin':
                    return 'margin-top: 0.5em;';
                case 'halfBottomMargin':
                    return 'margin-bottom: 0.5em;';
                default:
                    return '';
            }
        }
    }
    return '';
}
var ExtendedP = styled__default.p(templateObject_1$g || (templateObject_1$g = __makeTemplateObject(["\n  font-family: ", ";\n  font-size: ", ";\n  color: ", ";\n  ", ";\n  ", ";\n  font-weight: ", ";\n"], ["\n  font-family: ",
    ";\n  font-size: ", ";\n  color: ", ";\n  ", ";\n  ", ";\n  font-weight: ",
    ";\n"])), function (props) {
    return props.options.fontFamily ? props.options.fontFamily : regularFont;
}, function (props) { return setFontSize$3(props.options.size); }, function (props) { return props.options.color; }, function (props) { return props.options && "text-transform: " + props.options.textTransform; }, function (props) { return getMargin$1(props); }, function (props) {
    return props.options.fontWeight ? props.options.fontWeight : 400;
});
var P = function (props) {
    var children = props.children, color = props.color, size = props.size, style = props.style, fontWeight = props.fontWeight, fontFamily = props.fontFamily, _a = props.textTransform, textTransform = _a === void 0 ? 'none' : _a, _b = props.margin, margin = _b === void 0 ? '' : _b, _c = props.halfMargin, halfMargin = _c === void 0 ? '' : _c, as = props.as, rest = __rest(props, ["children", "color", "size", "style", "fontWeight", "fontFamily", "textTransform", "margin", "halfMargin", "as"]);
    return (React.createElement(ExtendedP, __assign({ as: as, options: {
            color: color,
            size: size,
            textTransform: textTransform,
            margin: margin,
            halfMargin: halfMargin,
            fontWeight: fontWeight,
            fontFamily: fontFamily,
        }, style: style }, rest), children));
};
var templateObject_1$g;

exports.Button = Button;
exports.ButtonGroup = ButtonGroup;
exports.FormGroup = FormGroup;
exports.RadioButton = RadioButton;
exports.Checkbox = Checkbox;
exports.Toggle = Checkbox$1;
exports.TextArea = TextArea;
exports.TextInput = TextInput;
exports.UnderlineTextField = UnderlineTextField;
exports.Dialog = Dialog;
exports.Slider = Slider;
exports.Select = Select;
exports.DaySlider = DaySlider;
exports.H1 = H1;
exports.H2 = H2;
exports.H3 = H3;
exports.P = P;
//# sourceMappingURL=index.js.map
